
#include <stdio.h>
#include <us.h>

int Size;
float * * a, * * b, * * c;
InitProblemOnce ()
{   int i, j;
    a = (float * *) UsAllocScatterMatrix (Size, Size, sizeof(float));
    b = (float * *) UsAllocScatterMatrix (Size, Size, sizeof(float));
    c = (float * *) UsAllocScatterMatrix (Size, Size, sizeof(float));
    ShareScatterMatrix (& a, Size);
    Share (& b);
    Share (& c);
    for (i = 0; i < Size; i++)
          for (j = 0; j < Size; j++)
          {   if (i==j) b[i][j] = 3.; else b[i][j] = 0.;
               c[i][j] = Size * i + j;
          }
}
InitPerRun () 
{   int i, j;
    for (i = 0; i < Size; i++)
          for (j = 0; j < Size; j++)
                a[i][j] = 0.;
}
DotProduct (dummy, i, j)
    int dummy, i, j;
{   int k;
    float * bb = b[i], * cc = c[j], temp = 0.0;
    for (k = 0; k < Size; k++)
     temp += *bb++ * *cc++;
    a[i][j] = temp;
}
Body ()
{   GenOnA (DotProduct, Size, Size);
}
PrintAnswer (time, procs, speedup)
    int time, procs; float speedup;
{   int i, j;
    for (i = 0; i < 6; i++)
    {     printf ("\na row %d ", i);
          for (j = 0; j < 6; j++)
                printf ("%d. ", (int) a[i][j]);
    }
    printf ("\n");
    TimeTestPrint (time, procs, speedup);
}
main ()
{   InitializeUs ();
    printf ("\nStarting Matrix Multiply\nMatrix Size: ");
#ifdef PSOS_OS
    fflush(stdout);
#endif
    scanf ("%d", &Size);
    Share (&Size);
    InitProblemOnce ();
    TimeTest (InitPerRun, Body, PrintAnswer);

#ifdef PSOS_OS
    m_terminate();
#else
    exit(0);
#endif
}
