/* $Header: bbn_atomic.h,v 1.3 90/02/14 14:15:23 gibson Exp $ */
#ifndef _BBN_ATOMIC_H
#define _BBN_ATOMIC_H

/* ATOMIC CLEAR-THEN-ADD */
    /* Signed and unsigned versions of clear-then-add for 32,16, and 8 bits */
#ifdef BFLY2
int		atomcta32();
short		atomcta16();
#endif BFLY2

unsigned int	atomctau32();
unsigned short	atomctau16();

#ifdef BFLY2
char		atomcta8();
unsigned char	atomctau8();
#endif BFLY2

int		atomcta();	/* compatibility with old GP1000 routine */

/* ADD */
    /* Signed and unsigned versions of add for 32,16, and 8 bits */
int		atomadd32();
short		atomadd16();

unsigned int	atomaddu32();
unsigned short	atomaddu16();

#ifdef BFLY2
char		atomadd8();
unsigned char	atomaddu8();
#endif BFLY2

int		atomadd();	/* compatibility with old GP1000 routine */

/* ATOMIC AND */
    /* Only unsigned versions of and for 32,16, and 8 bits */
unsigned int	atomand32();
unsigned short	atomand16();
#ifdef BFLY2
unsigned char	atomand8();
#endif BFLY2

int		atomand();	/* compatibility with old GP1000 routine */

/* ATOMIC INCLUSIVE OR */
    /* Only unsigned versions of ior for 32,16, and 8 bits */
unsigned int	atomior32();
unsigned short	atomior16();
#ifdef BFLY2
unsigned char	atomior8();
#endif BFLY2

int		atomior();	/* compatibility with old GP1000 routine */

#ifdef BFLY2
/* ATOMIC FIND-FIRST-0-AND-SET */
    /* Only unsigned versions of ff0andset for 32,16, and 8 bits */
unsigned int	atomff0andset32();
unsigned short	atomff0andset16();
unsigned char	atomff0andset8();

/* ATOMIC FIND-FIRST-1-AND-CLEAR */
    /* Only unsigned versions of ff1andclear for 32,16, and 8 bits */
unsigned int	atomff1andclear32();
unsigned int	atomff1andclear16();
unsigned int	atomff1andclear8();
#endif BFLY2

/* ATOMIC LOAD AND STORE */
    /* Signed and unsigned versions of load and store for 32,16, and 8 bits */
#define	atomload32(addr)		(*((int *)(addr)))
#define	atomload16(addr)		(*((short *)(addr)))

#define	atomloadu32(addr)		(*((unsigned int *)(addr)))
#define	atomloadu16(addr)		(*((unsigned short *)(addr)))

#define	atomstore32(addr, value)	( (*((int *)(addr))) = ((int)(value)) )
#define	atomstore16(addr, value)	( (*((short *)(addr))) = ((int)(value)))

#define	atomstoreu32(addr, value)	\
	( (*((unsigned int *)(addr))) = ((unsigned int)(value)) )
#define	atomstoreu16(addr, value)	\
	( (*((unsigned short *)(addr))) = ((unsigned int)(value)))

#ifdef BFLY2
#define	atomload8(addr)			(*((char *)(addr)))
#define	atomloadu8(addr)		(*((unsigned char *)(addr)))
#define	atomstore8(addr, value)		( (*((char *)(addr))) = ((int)(value)) )
#define	atomstoreu8(addr, value)		\
	( (*((unsigned char *)(addr))) = ((unsigned int)(value)) )
#endif BFLY2

#ifdef BFLY2
/* ATOMIC COMPARE-AND_SWAP */
    /* 32-bit version only */
int		atomcas32();
#endif BFLY2

#endif _BBN_ATOMIC_H
