/* $Header: /nfs/europa/usr/BF2USRSRC/include/RCS/bbn_errors.h,v 1.2 90/07/30 15:10:51 rschaaf Exp $ */

/*********************************************************************
*                                                                    *
*  BBN DEFINED ERROR CODES                                           *
*                                                                    *
*********************************************************************/

#ifndef BBN_ERROR_H
#define BBN_ERROR_H

/* 0 = SUCCESS */

#ifdef	BFLY2
/* pSOS uses 1 to 0xFFF */


/* VME Error Codes */

#define EVME_ERROR_BASE    	(0xF000)

#define EVME_SYSFAIL_HUNG  	(EVME_ERROR_BASE + 1) 
#define EVME_MMAP_CHECK    	(EVME_ERROR_BASE + 2) /* Master map data ck failed */
#define EVME_NOSPACE       	(EVME_ERROR_BASE + 3) /* Master or slave map full  */
#define EVME_INVALID_ARG   	(EVME_ERROR_BASE + 4)

#define EVME_ERROR_MAX     	(EVME_INVALID_ARG)
#endif	BFLY2


/* Shared object error codes */

#define OBJECT_ERROR_BASE       0xF100

#define OBJECT_OK       	0
#define OBJECT_LOCKED   	(OBJECT_ERROR_BASE + 1 )
#define OBJECT_NOT_LOCKED       (OBJECT_ERROR_BASE + 2 )
#define OBJECT_EXISTS   	(OBJECT_ERROR_BASE + 3 )
#define OBJECT_DOESNT_EXIST   	(OBJECT_ERROR_BASE + 4 )
#define OBJECT_WRITE_ERROR  	(OBJECT_ERROR_BASE + 5 )
#define OBJECT_READ_ERROR   	(OBJECT_ERROR_BASE + 6 )
#define OBJECT_SEEK_ERROR   	(OBJECT_ERROR_BASE + 7 )
#define OBJECT_OPEN_ERROR   	(OBJECT_ERROR_BASE + 8 )
#define OBJECT_CLOSE_ERROR   	(OBJECT_ERROR_BASE + 9 )
#define OBJECT_UNLINK_ERROR   	(OBJECT_ERROR_BASE + 10)
#define OBJECT_MALLOC_ERROR     (OBJECT_ERROR_BASE + 11)
#define OBJECT_DIR_ERROR        (OBJECT_ERROR_BASE + 12)

#define OBJECT_ERROR_MAX        (OBJECT_DIR_ERROR)


/* Shared memory error codes */

#define SHMEM_ERROR_BASE                0xF200

#define SHARED_MEM_OK           	0
#define SHARED_MEM_IN_USE       	(SHMEM_ERROR_BASE + 1 )
#define SHARED_MEM_NOT_IN_USE   	(SHMEM_ERROR_BASE + 2 )
#define SHARED_MEM_NOT_CREATOR  	(SHMEM_ERROR_BASE + 3 )
#define SHARED_MEM_MAX_USERS    	(SHMEM_ERROR_BASE + 4 )
#define SHARED_MEM_BAD_MEM_TYPE 	(SHMEM_ERROR_BASE + 5 )
#define SHARED_MEM_OPEN_ERR     	(SHMEM_ERROR_BASE + 6 )
#define SHARED_MEM_VM_MAPMEM_ERR    	(SHMEM_ERROR_BASE + 7 )
#define SHARED_MEM_MALLOC_ERR       	(SHMEM_ERROR_BASE + 8 )
#define SHARED_MEM_BAD_DESC     	(SHMEM_ERROR_BASE + 9 )
#define SHARED_MEM_PSOS_MAP_ERR         (SHMEM_ERROR_BASE + 10)
#define SHARED_MEM_UNINIT_CLUSTER       (SHMEM_ERROR_BASE + 11)
#define SHARED_MEM_CLUSTER_CTL_ERR      (SHMEM_ERROR_BASE + 12)

#define SHMEM_ERROR_MAX                 (SHARED_MEM_CLUSTER_CTL_ERR)

#ifdef	BFLY2
/* ICC error codes */

#define ICC_ERROR_BASE                  0xF300

#define ICC_OK	0

typedef enum icc_rc_e {
  ICC_EBADICC = ICC_ERROR_BASE,
  ICC_EINACTIVE,
  ICC_EMEMORY,
  ICC_EMAPPING,
  ICC_EBUFSIZE,
  ICC_ENOBUF,
  ICC_ENOTALIGNED,
  ICC_EBADBUF,
  ICC_EBADADDR,
  ICC_EBADOFFSET,
  ICC_EQFULL,
  ICC_EQEMPTY,
  ICC_EWAKEUP,
  ICC_EMAXPENDING,
  ICC_ETIMEOUT,
  ICC_ELOCK,
  ICC_ERINGBUF,
  ICC_EATTACHED,
  ICC_EOSERROR,
  ICC_EBADVERSION,
} ICC_RC;

#define ICC_ERROR_MAX                 (ICC_EBADVERSION)


/* Virtual memory error codes */

#define VM_ERROR_BASE		0xF400
#define VM_SUCCESS		0
#define VM_MISALIGNED		(VM_ERROR_BASE + 1)
#define VM_NOSPACE		(VM_ERROR_BASE + 2)
#define VM_NOPAGETABLES		(VM_ERROR_BASE + 3)
#define VM_INVALIDARG		(VM_ERROR_BASE + 4)
#define VM_NOMAPPING		(VM_ERROR_BASE + 5)

#define VM_ERROR_MAX		(VM_NOMAPPING)
#endif	BFLY2

#endif BBN_ERROR_H
