/* $Header: error_msg.h,v 1.1 90/02/20 08:55:22 tdonahue Exp $ */

/*********************************************************************
*                                                                    *
*  Error message structure                                           *
*                                                                    *
*********************************************************************/

#ifndef ERROR_MSG_H
#define ERROR_MSG_H


struct error_msg
    {
    int  error_code;
    char *error_string;
    };

typedef struct error_msg ERROR_MSG;

/* NOTE: ERROR LIST MUST BE TERMINATED BY A 'ZERO' ENTRY */

/* ---------- sample error list ----------

ERROR_MSG sample_errors[]
    {
    { ERR_1, "error number 1"       },
    { ERR_2, "error number 2"       },
    { 0,     "unknown sample error" }
    };

-------------------------------------------*/


/*********************************************************************
*                                                                    *
*  Error table structure                                             *
*                                                                    *
*********************************************************************/

struct error_table
    {
    ERROR_MSG   *error_list;
    int         min_error_value;
    int         max_error_value;
    };

typedef struct error_table ERROR_TABLE;



/*********************************************************************
*                                                                    *
*  Externs                                                           *
*                                                                    *
*********************************************************************/

char *get_error_message ();


#endif ERROR_MSG_H
