#ifdef BFLY1
/*
 *	definitions of MC68881 status register & control register bits
 */

/*
 * rounding mode control
 */
#define FP_RN		0x00	/* round to nearest */
#define FP_RZ		0x10	/* round to zero (truncate) */
#define FP_RM		0x20	/* round to minus */
#define FP_RP		0x30	/* round to plus */

/*
 * exception enable mask / exception status
 */
#define FP_BSUN		0x8000	/* branch/set on unordered */
#define FP_SNAN		0x4000	/* signalling NAN */
#define FP_OPERR	0x2000	/* operand error */
#define FP_OVFL		0x1000	/* overflow */
#define FP_UNFL		0x0800	/* undeflow */
#define FP_DZ		0x0400	/* divide by zero */
#define FP_INEX2	0x0200	/* inexact operation */
#define FP_INEX1	0x0100	/* inexact decimal input */

/*
 * accrued exceptions
 *
 *	Note:  these bits are defined as if they were in the
 *		exception status byte of FPSR.  The routines
 *		fp[gs]etsticky shift them consistently.
 */
#define FP_X_INV	(FP_OPERR | FP_SNAN | FP_BSUN)	/* invalid operation */
#define FP_X_OFL	FP_OVFL				/* overflow exception */
#define FP_X_UFL	FP_UNFL				/* underflow exception */
#define FP_X_DZ		FP_DZ				/* divide-by-zero */
#define FP_X_IMP	(FP_INEX1 | FP_INEX2)		/* imprecise */
#endif BFLY1
#ifdef BFLY2

/*
 *      definitions of MC88100 status register & control register bits
 */

/*
 * rounding mode control
 */
#define FP_RN           0x0000  /* round to nearest */
#define FP_RZ           0x4000  /* round to zero (truncate) */
#define FP_RM           0x8000  /* round to minus */
#define FP_RP           0xc000  /* round to plus */

/*
 * exception enable mask
 */
#define FP_OPERR        0x10    /* operand error */
#define FP_OVFL         0x02    /* overflow */
#define FP_UNFL         0x04    /* undeflow */
#define FP_DZ           0x08    /* divide by zero */
#define FP_INEX2        0x01    /* inexact operation */

/*
 * accrued exceptions
 *
 */
#define FP_X_INV        FP_OPERR                        /* invalid operation */
#define FP_X_OFL        FP_OVFL                         /* overflow exception */
#define FP_X_UFL        FP_UNFL                         /* underflow exception */
#define FP_X_DZ         FP_DZ                           /* divide-by-zero */
#define FP_X_IMP        FP_INEX2                        /* imprecise */

#endif BFLY2
