/*
 * Copyrighted as an unpublished work.
 * (c) Copyright 1989 INTERACTIVE Systems Corporation
 * All rights reserved.
 *
 * RESTRICTED RIGHTS
 *
 * These programs are supplied under a license.  They may be used,
 * disclosed, and/or copied only as permitted under such license
 * agreement.  Any copy must contain the above copyright notice and
 * this restricted rights notice.  Use, copying, and/or disclosure
 * of the programs is strictly prohibited unless otherwise provided
 * in the license agreement.
 */


/*
 *	locale.h
 *
 *	created from X3J11 Draft document of 12-7-1988
 *
 *	ZUB (INTERACTIVE Systems)
 */

#ifndef _LOCALE_H
#define _LOCALE_H

#define LC_ALL		0
#define LC_COLLATE	1
#define LC_CTYPE	2
#define	LC_MONETARY	3
#define LC_NUMERIC	4
#define LC_TIME		5

struct lconv {
	char	*decimal_point;		/* for non-monetary quantaties */
	char	*thousands_sep;		/* to separate groups of digits ,, */
	char	*grouping;		/* size of digit group in ,, */
	char	*int_curr_symbol;	/* international currency symbol */
	char	*currency_symbol;	/* local currency symbol */
	char	*mon_decimal_point;	/* for monetary quantaties */
	char	*mon_thousands_sep;	/* to spearate groups of digits ,, */
	char	*mon_grouping;		/* size of digit group in ,, */
	char	*positive_sign;		/* str for non-neg mon value */
	char	*negative_sign;		/* str for negative mon value */
	char	int_frac_digits;	/* international default precision */
	char	frac_digits;		/* default precision */
	char	p_cs_precedes;		/* cur sym pre/succeeds pos num */
	char	p_sep_by_space;		/* cur sym sep/not-sep from pos num */
	char	n_cs_precedes;		/* cur sym pre/succeeds neg num */
	char	n_sep_by_space;		/* cur sym sep/not-sep from neg num */
	char	p_sign_posn;		/* position for pos sign for mon num */
	char	n_sign_posn;		/* position for neg sign for mon num */
};

extern char	*setlocale();

#endif _LOCALE_H
