#ifndef	_mach
#define	_mach	       1

/* Module mach */
#ifdef	KERNEL
#include "../h/kern_return.h"
#else	KERNEL
#include <sys/kern_return.h>
#endif	KERNEL
#if	LINTLIBRARY
#ifdef	KERNEL
#include "../h/port.h"
#else	KERNEL
#include <sys/port.h>
#endif	KERNEL
#endif	LINTLIBRARY
extern void init_mach();

#include "mach_types.h"

extern kern_return_t	port_allocate( 
#if	LINTLIBRARY
		ServPort,my_port)
	task_t		ServPort;
	port_t		*my_port;
		{ return(port_allocate(ServPort,my_port)); }
#else	LINTLIBRARY
		);
#endif	LINTLIBRARY

extern kern_return_t	port_deallocate( 
#if	LINTLIBRARY
		ServPort,my_port)
	task_t		ServPort;
	port_t		my_port;
		{ return(port_deallocate(ServPort,my_port)); }
#else	LINTLIBRARY
		);
#endif	LINTLIBRARY

extern kern_return_t	port_enable( 
#if	LINTLIBRARY
		ServPort,my_port)
	task_t		ServPort;
	port_t		my_port;
		{ return(port_enable(ServPort,my_port)); }
#else	LINTLIBRARY
		);
#endif	LINTLIBRARY

extern kern_return_t	port_disable( 
#if	LINTLIBRARY
		ServPort,my_port)
	task_t		ServPort;
	port_t		my_port;
		{ return(port_disable(ServPort,my_port)); }
#else	LINTLIBRARY
		);
#endif	LINTLIBRARY

extern kern_return_t	port_select( 
#if	LINTLIBRARY
		ServPort,port_list,port_list_Cnt)
	task_t		ServPort;
	port_array_t	*port_list;
	int		*port_list_Cnt;
		{ return(port_select(ServPort,port_list,port_list_Cnt)); }
#else	LINTLIBRARY
		);
#endif	LINTLIBRARY

extern kern_return_t	port_set_backlog( 
#if	LINTLIBRARY
		ServPort,my_port,backlog)
	task_t		ServPort;
	port_t		my_port;
	int		backlog;
		{ return(port_set_backlog(ServPort,my_port,backlog)); }
#else	LINTLIBRARY
		);
#endif	LINTLIBRARY

extern kern_return_t	port_status( 
#if	LINTLIBRARY
		ServPort,my_port,enabled,num_msgs,backlog)
	task_t		ServPort;
	port_t		my_port;
	boolean_t	*enabled;
	int		*num_msgs;
	int		*backlog;
		{ return(port_status(ServPort,my_port,enabled,num_msgs,backlog)); }
#else	LINTLIBRARY
		);
#endif	LINTLIBRARY

extern kern_return_t	task_create( 
#if	LINTLIBRARY
		ServPort,inherit_memory,child_task,child_data)
	task_t		ServPort;
	boolean_t	inherit_memory;
	task_t		*child_task;
	port_t		*child_data;
		{ return(task_create(ServPort,inherit_memory,child_task,child_data)); }
#else	LINTLIBRARY
		);
#endif	LINTLIBRARY

extern kern_return_t	task_terminate( 
#if	LINTLIBRARY
		ServPort)
	task_t		ServPort;
		{ return(task_terminate(ServPort)); }
#else	LINTLIBRARY
		);
#endif	LINTLIBRARY

extern kern_return_t	task_suspend( 
#if	LINTLIBRARY
		ServPort)
	task_t		ServPort;
		{ return(task_suspend(ServPort)); }
#else	LINTLIBRARY
		);
#endif	LINTLIBRARY

extern kern_return_t	task_resume( 
#if	LINTLIBRARY
		ServPort)
	task_t		ServPort;
		{ return(task_resume(ServPort)); }
#else	LINTLIBRARY
		);
#endif	LINTLIBRARY

extern kern_return_t	task_threads( 
#if	LINTLIBRARY
		ServPort,thread_list,thread_list_Cnt)
	task_t		ServPort;
	thread_array_t	*thread_list;
	int		*thread_list_Cnt;
		{ return(task_threads(ServPort,thread_list,thread_list_Cnt)); }
#else	LINTLIBRARY
		);
#endif	LINTLIBRARY

extern kern_return_t	task_ports( 
#if	LINTLIBRARY
		ServPort,port_list,port_list_Cnt)
	task_t		ServPort;
	port_array_t	*port_list;
	int		*port_list_Cnt;
		{ return(task_ports(ServPort,port_list,port_list_Cnt)); }
#else	LINTLIBRARY
		);
#endif	LINTLIBRARY

extern kern_return_t	task_status( 
#if	LINTLIBRARY
		ServPort,notify_port,resumed)
	task_t		ServPort;
	port_t		*notify_port;
	boolean_t	*resumed;
		{ return(task_status(ServPort,notify_port,resumed)); }
#else	LINTLIBRARY
		);
#endif	LINTLIBRARY

extern kern_return_t	task_set_notify( 
#if	LINTLIBRARY
		ServPort,notify_port)
	task_t		ServPort;
	port_t		notify_port;
		{ return(task_set_notify(ServPort,notify_port)); }
#else	LINTLIBRARY
		);
#endif	LINTLIBRARY

extern kern_return_t	thread_create( 
#if	LINTLIBRARY
		ServPort,child_thread,child_data)
	task_t		ServPort;
	thread_t	*child_thread;
	port_t		*child_data;
		{ return(thread_create(ServPort,child_thread,child_data)); }
#else	LINTLIBRARY
		);
#endif	LINTLIBRARY

extern kern_return_t	thread_terminate( 
#if	LINTLIBRARY
		ServPort)
	thread_t	ServPort;
		{ return(thread_terminate(ServPort)); }
#else	LINTLIBRARY
		);
#endif	LINTLIBRARY

extern kern_return_t	thread_suspend( 
#if	LINTLIBRARY
		ServPort)
	thread_t	ServPort;
		{ return(thread_suspend(ServPort)); }
#else	LINTLIBRARY
		);
#endif	LINTLIBRARY

extern kern_return_t	thread_resume( 
#if	LINTLIBRARY
		ServPort)
	thread_t	ServPort;
		{ return(thread_resume(ServPort)); }
#else	LINTLIBRARY
		);
#endif	LINTLIBRARY

extern kern_return_t	thread_status( 
#if	LINTLIBRARY
		ServPort,resumed,old_state)
	thread_t	ServPort;
	boolean_t	*resumed;
	thread_status_t	*old_state;
		{ return(thread_status(ServPort,resumed,old_state)); }
#else	LINTLIBRARY
		);
#endif	LINTLIBRARY

extern kern_return_t	thread_mutate( 
#if	LINTLIBRARY
		ServPort,new_state)
	thread_t	ServPort;
	thread_status_t	new_state;
		{ return(thread_mutate(ServPort,new_state)); }
#else	LINTLIBRARY
		);
#endif	LINTLIBRARY

extern kern_return_t	vm_allocate( 
#if	LINTLIBRARY
		ServPort,address,size,anywhere)
	vm_task_t	ServPort;
	vm_address_t	*address;
	vm_size_t	size;
	boolean_t	anywhere;
		{ return(vm_allocate(ServPort,address,size,anywhere)); }
#else	LINTLIBRARY
		);
#endif	LINTLIBRARY

extern kern_return_t	vm_allocate_with_pager( 
#if	LINTLIBRARY
		ServPort,address,size,anywhere,paging_object,offset)
	vm_task_t	ServPort;
	vm_address_t	*address;
	vm_size_t	size;
	boolean_t	anywhere;
	paging_object_t	paging_object;
	vm_offset_t	offset;
		{ return(vm_allocate_with_pager(ServPort,address,size,anywhere,paging_object,offset)); }
#else	LINTLIBRARY
		);
#endif	LINTLIBRARY

extern kern_return_t	vm_deallocate( 
#if	LINTLIBRARY
		ServPort,address,size)
	vm_task_t	ServPort;
	vm_address_t	address;
	vm_size_t	size;
		{ return(vm_deallocate(ServPort,address,size)); }
#else	LINTLIBRARY
		);
#endif	LINTLIBRARY

extern kern_return_t	vm_protect( 
#if	LINTLIBRARY
		ServPort,address,size,set_maximum,new_protection)
	vm_task_t	ServPort;
	vm_address_t	address;
	vm_size_t	size;
	boolean_t	set_maximum;
	vm_prot_t	new_protection;
		{ return(vm_protect(ServPort,address,size,set_maximum,new_protection)); }
#else	LINTLIBRARY
		);
#endif	LINTLIBRARY

extern kern_return_t	vm_inherit( 
#if	LINTLIBRARY
		ServPort,address,size,new_inheritance)
	vm_task_t	ServPort;
	vm_address_t	address;
	vm_size_t	size;
	vm_inherit_t	new_inheritance;
		{ return(vm_inherit(ServPort,address,size,new_inheritance)); }
#else	LINTLIBRARY
		);
#endif	LINTLIBRARY

extern kern_return_t	vm_read( 
#if	LINTLIBRARY
		ServPort,address,size,data,data_Cnt)
	vm_task_t	ServPort;
	vm_address_t	address;
	vm_size_t	size;
	pointer_t	*data;
	int		*data_Cnt;
		{ return(vm_read(ServPort,address,size,data,data_Cnt)); }
#else	LINTLIBRARY
		);
#endif	LINTLIBRARY

extern kern_return_t	vm_write( 
#if	LINTLIBRARY
		ServPort,address,data,data_Cnt)
	vm_task_t	ServPort;
	vm_address_t	address;
	pointer_t	data;
	int		data_Cnt;
		{ return(vm_write(ServPort,address,data,data_Cnt)); }
#else	LINTLIBRARY
		);
#endif	LINTLIBRARY

extern kern_return_t	vm_copy( 
#if	LINTLIBRARY
		ServPort,source_address,size,dest_address)
	vm_task_t	ServPort;
	vm_address_t	source_address;
	vm_size_t	size;
	vm_address_t	dest_address;
		{ return(vm_copy(ServPort,source_address,size,dest_address)); }
#else	LINTLIBRARY
		);
#endif	LINTLIBRARY

extern kern_return_t	vm_regions( 
#if	LINTLIBRARY
		ServPort,address,size,regions,regions_Cnt)
	vm_task_t	ServPort;
	vm_address_t	address;
	vm_size_t	size;
	vm_region_array_t	*regions;
	int		*regions_Cnt;
		{ return(vm_regions(ServPort,address,size,regions,regions_Cnt)); }
#else	LINTLIBRARY
		);
#endif	LINTLIBRARY

extern kern_return_t	vm_statistics( 
#if	LINTLIBRARY
		ServPort,vm_stats)
	vm_task_t	ServPort;
	vm_statistics_data_t	*vm_stats;
		{ return(vm_statistics(ServPort,vm_stats)); }
#else	LINTLIBRARY
		);
#endif	LINTLIBRARY

extern kern_return_t	pager_clean( 
#if	LINTLIBRARY
		ServPort,pager_space,offset,size)
	port_t		ServPort;
	int		pager_space;
	vm_offset_t	offset;
	vm_size_t	size;
		{ return(pager_clean(ServPort,pager_space,offset,size)); }
#else	LINTLIBRARY
		);
#endif	LINTLIBRARY

extern kern_return_t	pager_fetch( 
#if	LINTLIBRARY
		ServPort,pager_space,offset,size)
	port_t		ServPort;
	int		pager_space;
	vm_offset_t	offset;
	vm_size_t	size;
		{ return(pager_fetch(ServPort,pager_space,offset,size)); }
#else	LINTLIBRARY
		);
#endif	LINTLIBRARY

extern kern_return_t	mach_ports_register( 
#if	LINTLIBRARY
		ServPort,init_port_set,init_port_set_Cnt)
	task_t		ServPort;
	port_array_t	init_port_set;
	int		init_port_set_Cnt;
		{ return(mach_ports_register(ServPort,init_port_set,init_port_set_Cnt)); }
#else	LINTLIBRARY
		);
#endif	LINTLIBRARY

extern kern_return_t	mach_ports_lookup( 
#if	LINTLIBRARY
		ServPort,init_port_set,init_port_set_Cnt)
	task_t		ServPort;
	port_array_t	*init_port_set;
	int		*init_port_set_Cnt;
		{ return(mach_ports_lookup(ServPort,init_port_set,init_port_set_Cnt)); }
#else	LINTLIBRARY
		);
#endif	LINTLIBRARY

extern kern_return_t	unix_pid( 
#if	LINTLIBRARY
		ServPort,process_id)
	task_t		ServPort;
	int		*process_id;
		{ return(unix_pid(ServPort,process_id)); }
#else	LINTLIBRARY
		);
#endif	LINTLIBRARY

extern kern_return_t	netipc_listen( 
#if	LINTLIBRARY
		ServPort,src_addr,dst_addr,src_port,dst_port,protocol,ipc_port)
	port_t		ServPort;
	int		src_addr;
	int		dst_addr;
	int		src_port;
	int		dst_port;
	int		protocol;
	port_t		ipc_port;
		{ return(netipc_listen(ServPort,src_addr,dst_addr,src_port,dst_port,protocol,ipc_port)); }
#else	LINTLIBRARY
		);
#endif	LINTLIBRARY

extern kern_return_t	netipc_ignore( 
#if	LINTLIBRARY
		ServPort,ipc_port)
	port_t		ServPort;
	port_t		ipc_port;
		{ return(netipc_ignore(ServPort,ipc_port)); }
#else	LINTLIBRARY
		);
#endif	LINTLIBRARY

extern kern_return_t	pager_data_provided( 
#if	LINTLIBRARY
		ServPort,offset,data,data_Cnt,lock_value)
	port_t		ServPort;
	vm_offset_t	offset;
	pointer_t	data;
	int		data_Cnt;
	vm_prot_t	lock_value;
		{ return(SEND_SUCCESS); }
#else	LINTLIBRARY
		);
#endif	LINTLIBRARY

extern kern_return_t	pager_data_unavailable( 
#if	LINTLIBRARY
		ServPort,offset,size)
	port_t		ServPort;
	vm_offset_t	offset;
	vm_size_t	size;
		{ return(SEND_SUCCESS); }
#else	LINTLIBRARY
		);
#endif	LINTLIBRARY

extern kern_return_t	pager_data_lock( 
#if	LINTLIBRARY
		ServPort,offset,size,lock_value)
	port_t		ServPort;
	vm_offset_t	offset;
	vm_size_t	size;
	vm_prot_t	lock_value;
		{ return(pager_data_lock(ServPort,offset,size,lock_value)); }
#else	LINTLIBRARY
		);
#endif	LINTLIBRARY

extern kern_return_t	pager_clean_request( 
#if	LINTLIBRARY
		ServPort,offset,size)
	port_t		ServPort;
	vm_offset_t	offset;
	vm_size_t	size;
		{ return(pager_clean_request(ServPort,offset,size)); }
#else	LINTLIBRARY
		);
#endif	LINTLIBRARY

extern kern_return_t	pager_flush_request( 
#if	LINTLIBRARY
		ServPort,offset,size)
	port_t		ServPort;
	vm_offset_t	offset;
	vm_size_t	size;
		{ return(pager_flush_request(ServPort,offset,size)); }
#else	LINTLIBRARY
		);
#endif	LINTLIBRARY

extern kern_return_t	pager_readonly( 
#if	LINTLIBRARY
		ServPort)
	port_t		ServPort;
		{ return(SEND_SUCCESS); }
#else	LINTLIBRARY
		);
#endif	LINTLIBRARY

extern kern_return_t	pager_cache( 
#if	LINTLIBRARY
		ServPort,should_cache)
	port_t		ServPort;
	boolean_t	should_cache;
		{ return(SEND_SUCCESS); }
#else	LINTLIBRARY
		);
#endif	LINTLIBRARY

#endif	_mach
