/*
 * Copyright (c) 1986 Carnegie-Mellon University
 */

/*
 *	Items provided by the Mach environment initialization.
 */

#ifndef	_MACH_INIT_
#define	_MACH_INIT_	1

#include <sys/port.h>
#include <sys/vm.h>

/*
 *	Kernel-related ports; how a task/thread controls itself
 */

extern	port_t	task_self_;
extern	port_t	task_data_;
extern	port_t	task_notify_;

#define	task_self()	task_self_
#define	task_data()	task_data_
#define	task_notify()	task_notify_

#define	current_task()	task_self()

/*
 *	Other important ports in the Mach user environment
 */

#define	NameServerPort	name_server_port	/* compatibility */

extern	port_t	name_server_port;
extern	port_t	environment_port;
extern	port_t	service_port;

/*
 *	Where these ports occur in the "mach_ports_register"
 *	collection... only servers or the runtime library need know.
 */

#if	MACH_INIT_SLOTS
#define	NAME_SERVER_SLOT	0
#define	ENVIRONMENT_SLOT	1
#define SERVICE_SLOT		2

#define	MACH_PORTS_SLOTS_USED	3

#if	MACH_IPC || MACH_ACC
extern	port_array_t	mach_init_ports;
extern	long		mach_init_ports_count;
#endif	MACH_IPC || MACH_ACC
#endif	MACH_INIT_SLOTS

/*
 *	Globally interesting numbers
 */

extern	vm_size_t	vm_page_size;

#endif	_MACH_INIT_
