#
/*
 ****************************************************************
 * Mach Operating System
 * Copyright (c) 1986 Carnegie-Mellon University
 *  
 * This software was developed by the Mach operating system
 * project at Carnegie-Mellon University's Department of Computer
 * Science. Software contributors as of May 1986 include Mike Accetta, 
 * Robert Baron, William Bolosky, Jonathan Chew, David Golub, 
 * Glenn Marcy, Richard Rashid, Avie Tevanian and Michael Young. 
 * 
 * Some software in these files are derived from sources other
 * than CMU.  Previous copyright and other source notices are
 * preserved below and permission to use such software is
 * dependent on licenses from those institutions.
 * 
 * Permission to use the CMU portion of this software for 
 * any non-commercial research and development purpose is
 * granted with the understanding that appropriate credit
 * will be given to CMU, the Mach project and its authors.
 * The Mach project would appreciate being notified of any
 * modifications and of redistribution of this software so that
 * bug fixes and enhancements may be distributed to users.
 *
 * All other rights are reserved to Carnegie-Mellon University.
 ****************************************************************
 */

/*
 * Mach Interface Generator errors
 *
 * HISTORY
 * 31-Jul-86  Michael Young (mwyoung) at Carnegie-Mellon University
 *	Created.
 */

#define	MIG_TYPE_ERROR		-300		/* Type check failure */
#define	MIG_REPLY_MISMATCH	-301		/* Wrong return message ID */
#define	MIG_REMOTE_ERROR	-302		/* Server detected error */
#define	MIG_BAD_ID		-303		/* Bad message ID */
#define	MIG_BAD_ARGUMENTS	-304		/* Server found wrong arguments */
#define	MIG_NO_REPLY		-305		/* Server shouldn't reply */
#define	MIG_EXCEPTION		-306		/* Server raised exception */
