/* $Header: /nfs/europa/usr/BF2USRSRC/include/RCS/setjmp.h,v 1.12 90/06/03 19:39:04 rwells Exp $ */
/*	setjmp.h	4.1	83/05/03	*/

#ifndef _SETJMP_H
#define _SETJMP_H

/* These definitions work for setjmp and _setjmp interchangably.  setjmp */
/* calls sigstack and sigblock to set onstack and sigmask, and _setjmp */
/* just sets them to zero.  longjmp and _longjmp will work with jmp_buf */
/* saved by either setjmp or _setjmp; longjmp must be used to long jump */
/* out of a signal handler context, since some of its context is on the */
/* process kernel stack.  longjmp called on a _setjmp jmp_buf will clear */
/* the signal mask and not be on the signal stack; for most applications */
/* this is just fine and saves the cost of the sigstack and sigblock */
/* system calls in saving the jmp_buf context. */

/* Definitions for both the TC2000 (BFLY2) and GP1000 (BFLY1) are */
/* included here, so this header file will be used for both.  */

#ifdef BFLY2
/* For both setjp and _setjmp, the contents of jmp_buf are: */
/* onstack, sigmask, sp, fp, psr, pc, cr62-63, r14-r29, unused1-2. */
/* Note that r30 and r31 are other names for fp and sp. */
/* psr is always set to zero.  We use doubles to force 64 bit alignment. */

#ifndef ASSEMBLER

typedef double jmp_buf[13];

#ifdef _BBN_POSIX_SUPPORT
typedef double sigjmp_buf[14];

/* Gross hack */
#define	sigsetjmp(e, s) \
	(s == 0 ? (((int *)e)[_SETJMP_SAVEFLAG] = 0, _setjmp(e)) : \
		  (((int *)e)[_SETJMP_SAVEFLAG] = 1,  setjmp(e)))
 
/*int	sigsetjmp();*/
void	siglongjmp();
#endif _BBN_POSIX_SUPPORT

#endif /* not ASSEMBLER */

/* Word (int) offset definitions for use in assembly code: */
#define _SETJMP_ONSTACK	  0	/* sigstack struct; keep together in order. */
#define _SETJMP_SIGMASK	  1	/* setjmp used these two fields as a tmp */
#define _SETJMP_SP	  2
#define _SETJMP_FP	  3
#define _SETJMP_PSR	  4
#define _SETJMP_PC	  5
#define _SETJMP_CR62	  6
#define _SETJMP_CR63	  7
#define _SETJMP_R14	  8
#define _SETJMP_R15	  9
#define _SETJMP_R16	 10
#define _SETJMP_R17	 11
#define _SETJMP_R18	 12
#define _SETJMP_R19	 13
#define _SETJMP_R20	 14
#define _SETJMP_R21	 15
#define _SETJMP_R22	 16
#define _SETJMP_R23	 17
#define _SETJMP_R24	 18
#define _SETJMP_R25	 19
#define _SETJMP_R26	 20
#define _SETJMP_R27	 21
#define _SETJMP_R28	 22
#define _SETJMP_R29	 23
#define _SETJMP_UNUSED1	 24
#define _SETJMP_UNUSED2	 25
#ifdef _BBN_POSIX_SUPPORT
#define _SETJMP_SAVEFLAG 26
#define _SETJMP_UNUSED3  27
#endif _BBN_POSIX_SUPPORT

#endif BFLY2

#ifdef BFLY1
/* For both setjmp and _setjmp, the contents of jmp_buf are: */
/* onsstack, sigmask, sp, fp, sr, pc, pad, d2-d7, a2-a5, fp2-fp7. */

#ifndef ASSEMBLER

typedef int jmp_buf[34];	/* 136 bytes */

#ifdef _BBN_POSIX_SUPPORT
typedef int sigjmp_buf[35];	/* 140 bytes */

/* Gross hack */
#define		sigsetjmp(e, s) \
			(s == 0 ? (e[34] = 0, _setjmp(e)) : \
				  (e[34] = 1,  setjmp(e)))
 
/*int	sigsetjmp();*/
void	siglongjmp();
#endif _BBN_POSIX_SUPPORT

#endif /* not ASSEMBLER */

/* Byte (char) offset definitions for use in assembly code: */
#define _SETJMP_ONSTACK	  0	/*  4: a2@+ for sigcontext in signal.h */
#define _SETJMP_SIGMASK	  4	/*  4: a2@+ for sigcontext in signal.h */
#define _SETJMP_SP	  8	/*  4: a2@+ for sigcontext in signal.h */
#define _SETJMP_FP	 12	/*  4: a2@+ for sigcontext in signal.h */
#define _SETJMP_CCR	 16	/*  2: a2@+ for sigcontext in signal.h */
#define _SETJMP_PC	 18	/*  4: a2@ misalign, sigcontext in signal.h */
#define _SETJMP_PADDING  22	/*  2: to get back on long word alignment */
#define _SETJMP_D2       24	/*  4: moveml block */
#define _SETJMP_D3       28	/*  4: moveml block */
#define _SETJMP_D4       32	/*  4: moveml block */
#define _SETJMP_D5       36	/*  4: moveml block */
#define _SETJMP_D6       40	/*  4: moveml block */
#define _SETJMP_D7       44	/*  4: moveml block */
#define _SETJMP_A2       48	/*  4: moveml block */
#define _SETJMP_A3       52	/*  4: moveml block */
#define _SETJMP_A4       56	/*  4: moveml block */
#define _SETJMP_A5       60	/*  4: moveml block */
#define _SETJMP_F2       64	/* 12: fmovemx block */
#define _SETJMP_F3       76	/* 12: fmovemx block */
#define _SETJMP_F4       88	/* 12: fmovemx block */
#define _SETJMP_F5      100	/* 12: fmovemx block */
#define _SETJMP_F6      112	/* 12: fmovemx block */
#define _SETJMP_F7      124	/* 12: fmovemx block */
#define _SETJMP_UNUSED  136	/*  0: no bytes unused */

#ifdef _BBN_POSIX_SUPPORT
#define _SETJMP_SAVEFLAG 136	/* Optional 4 bytes for POSIX only */
#endif _BBN_POSIX_SUPPORT

#endif BFLY1

#endif _SETJMP_H
