/*****************************************************************************
* File: scsi.h - Definitions for the SCSI device class driver.               *
*****************************************************************************/

#define MAX_SCSI_REQUEST	16

typedef struct srb
	{
	struct buf			*buf;		/* buffer involved.				*/
	char				 scsi_flags; /* SCSI layer flags			*/
	char				 scsi_device;/* SCSI-bus target device		*/
	char				 scsi_message;	/* SCSI message byte		*/
	char				 scsi_status;   /* SCSI status byte			*/
	short				 scsi_dma;	/* DMA count 0=> no DMA			*/
	char				 reqlen;	/* length of request			*/
	char				 req [MAX_SCSI_REQUEST];
	} SRB;

#define SCSI_EXPECT_PHASEERROR 0x02 /* says to expect phase error   */
#define SCSI_MY_DATA	0x04	/* says upper layer does data phase */
#define SCSI_MY_MSG		0x08	/* says upper layer does msg phase	*/
#define SCSI_INPUT		0x10	/* says this is an input request	*/
#define SCSI_INTERRUPTED 0x20	/* says an interrupt occurred		*/
#define SCSI_ERROR		0x40	/* says something is wrong			*/

/* defns for the scsi_status byte									*/
#define EXTRACT_STATUS(s) (((s)>>1)&0xf)
#define SCSI_STATUS_OK				0
#define SCSI_STATUS_CHECK			1
#define SCSI_STATUS_BUSY			4
#define SCSI_STATUS_INTERMEDIATE 	8
#define SCSI_STATUS_RESCONFLICT	  0xC

#define SCSI_BLOCK_SIZE			  512

unsigned long xvtop ();
