/* $Header: sd.h,v 1.3 89/08/08 14:06:05 nkeene Exp $ */

/*****************************************************************************
* File: sd.h - SCSI Disk Driver definitions.                                 *
*                                                                            *
* Started 12/8/88 by drb                                                     *
*                                                                            *
* [And now, a few words from the legal department.]                          *
*                                                                            *
* Copyright 1988 by BBN Advanced Computers Inc.                              *
* ALL RIGHTS RESERVED                                                        *
*                                                                            *
* No part of this material may be reproduced, stored in a retrieval          *
* system, transmitted or used in any form or by any means, electronic,       *
* mechanical, photocopying, recording, or otherwise, without the prior       *
* written permission of, or express license from BBN Advanced Computers Inc. *
*                                                                            *
* RESTRICTED RIGHTS LEGEND                                                   *
*                                                                            *
* Use, duplication, or disclosure by the Government is subject to            *
* restrictions as set forth in subparagraph (c)(1)(ii) of the Rights to      *
* Technical Data and Computer Software clause at DFARS 52.227-7013.          *
*                                                                            *
* BBN Advanced Computers Inc.                                                *
* 10 Fawcett Street                                                          *
* Cambridge, Ma. 02238                                                       *
* 617-873-6000                                                               *
*****************************************************************************/


#define NUMPART 8

struct sd_part
    {
    unsigned int offset;
    unsigned int size;  
    };

struct sd
    {
    int     ident;
    int     flags;
	int     in_progress;
    struct  sd_part partab[NUMPART];    
	simple_lock_data_t lock;
    };

typedef struct sd SD;

/* flags */
#define NT_DRIVE_ALIVE    0x00000001
#define NT_DRIVE_THROTTLE 0x00000002

#define SCSI_COMMAND_INQUIRY 0x12
#define SCSI_COMMAND_READ  0x08
#define SCSI_COMMAND_WRITE 0x0A
#define SCSI_COMMAND_SENSE 0x03

#define NT_SCSI_IDENT  0x12345678

#define NT_THROTTLE_LOWATER 3

/* Minor device number mappings:
   low-order 3 bits: Partition Number
         next 1 bit: Adapter Number
         next 1 bit: Bus Number
        high 3 bits: Disk Number (SCSI bus ID)      */

#define dev_to_partition(d)((d)&0x07)
#define dev_to_adapter(d)(((d)>>3)&0x01)
#define dev_to_bus(d) (((d)>>4)&0x01)
#define dev_to_device(d)(((d)>>5)&0x07)

#define SECTOR_SIZE_IN_BYTES  512
#define SENSE_BYTE_COUNT 64  /* >= number of sense bytes expected */
