/*****************************************************************************
* File: smtdriver.h - Tandberg Cartridge Tape definitions                    *
*****************************************************************************/

/* drive mode setup templates.  Please refer to the tapedrive manual		*/

typedef struct
	{
	unsigned char command;	/* 1 */
	unsigned lun:3;		/* 2 */
	unsigned res0:5;
	unsigned char res1;	/* 3 */
	unsigned char res2;	/* 4 */
	unsigned char paramlen;	/* 5 */
	unsigned res3:1;	/* 6 */
	unsigned smp:1;
	unsigned res4:4;
	unsigned flag:1;
	unsigned link:1;
	} MODE1;

#define SIZEOF_MODE1 6

typedef struct
	{
	unsigned char res0;
	unsigned char res1;
	unsigned res2:3;
	unsigned bufmode:1;
	unsigned speed:4;
	unsigned char blkdesclen;
	unsigned char density;
	unsigned char res3;
	unsigned char res4;
	unsigned char res5;
	unsigned char res6;
	unsigned char res7;
	unsigned char blksizmsb;
	unsigned char blksizlsb;
	unsigned char vendpagecode;
	unsigned char writethresh;
	unsigned char readthresh;
	unsigned char bufsiz;
	unsigned char fscountmsb;
	unsigned char fscountlsb;
	unsigned char busthresh;
	unsigned char copythresh;
	unsigned char nsthresh;
	unsigned char csthresh;
	unsigned char loadfcn;
	unsigned char powupdelay;
	} MODE2;


typedef struct
	{
	unsigned char command;	/* 1 */
	unsigned lun:3;		/* 2 */
	unsigned res1:4;
	unsigned immed:1;
	unsigned char res2;	/* 3 */
	unsigned char res3;	/* 4 */
	unsigned res4:6;	/* 5 */
	unsigned retension:1;
	unsigned load:1;
	unsigned eot:1;		/* 6 */
	unsigned res5:5;
	unsigned flag:1;
	unsigned link:1;
	} LOADCMD;

#define SIZEOF_LOADCMD 6

typedef struct 
	{
	unsigned char command;	/* 1 */
	unsigned lun:3;		/* 2 */
	unsigned res1:4;
	unsigned immed:1;
	unsigned char nmarksmsb;/* 3 */	
	unsigned char nmarksisb;/* 4 */
	unsigned char nmarkslsb;/* 5 */
	unsigned res2:6;	/* 6 */
	unsigned flag:1;
	unsigned link:1;
	} FILEMARKCMD;

#define SIZEOF_FILEMARKCMD 6

typedef struct 
	{
	unsigned char command;	/* 1 */
	unsigned lun:3;		/* 2 */
	unsigned res1:4;
	unsigned setme:1;
	unsigned char nblocksmsb;/* 3 */
	unsigned char nblocksisb;/* 4 */
	unsigned char nblockslsb;/* 5 */
	unsigned res2:6;	/* 6 */
	unsigned flag:1;
	unsigned link:1;
	} RDWRCMD;

#define SIZEOF_RDWRCMD 6

typedef struct
	{
	unsigned char command;	/* 1 */
	unsigned lun:3;		/* 2 */
	unsigned res1:5;
	unsigned char res2;	/* 3 */
	unsigned char res3;	/* 4 */
	unsigned char nbytes;	/* 5 */
	unsigned char res4;	/* 6 */
	} SENSECMD;

#define SIZEOF_SENSECMD 6

typedef struct
	{
	unsigned char command;	/* 1 */
	unsigned lun:3;		/* 2 */
	unsigned res1:3;
	unsigned code:2;
	unsigned char countmsb;	/* 3 */
	unsigned char countisb;	/* 4 */
	unsigned char countlsb;	/* 5 */
	unsigned res2:6;	/* 6 */
	unsigned flag:1;
	unsigned link:1;
	} SPACECMD;

#define SIZEOF_SPACECMD 6

typedef struct
	{
	unsigned char command;	/* 1 */
	unsigned lun:3;		/* 2 */
	unsigned res1:4;
	unsigned setme:1;
	unsigned char res2;	/* 3 */
	unsigned char res3;	/* 4 */
	unsigned char res4;	/* 5 */
	unsigned res5:6;	/* 6 */
	unsigned flag:1;
	unsigned link:1;
	} ERASECMD;			

#define SIZEOF_ERASECMD 6

#define READ_COMMAND	0x08
#define WRITE_COMMAND   0x0A

#define SPACE_BLOCKS	0x00
#define SPACE_FILES		0x01
#define SPACE_EOT		0x03

#define SENSE_EOF       0x80
#define SENSE_EOT		0x40
