/*
 * Copyrighted as an unpublished work.
 * (c) Copyright 1989 INTERACTIVE Systems Corporation
 * All rights reserved.
 *
 * RESTRICTED RIGHTS
 *
 * These programs are supplied under a license.  They may be used,
 * disclosed, and/or copied only as permitted under such license
 * agreement.  Any copy must contain the above copyright notice and
 * this restricted rights notice.  Use, copying, and/or disclosure
 * of the programs is strictly prohibited unless otherwise provided
 * in the license agreement.
 */


/*
 *	tar.h
 *
 *	as specified in POSIX 1003.1-1988 specs
 */

#ifndef	_TAR_H
#define	_TAR_H

#define TMAGIC		"ustar"		/* ustar and a null */
#define TMAGLEN		6
#define TVERSION	"00"		/* 00 and no null */
#define TVERSLEN	2

/* Values used in typeflag field */
#define REGTYPE		'0'		/* Regular file */
#define AREGTYPE	'\0'		/* Regular file */
#define LNKTYPE		'1'		/* Link */
#define SYMTYPE		'2'		/* Reserved */
#define CHRTYPE		'3'		/* Character special */
#define BLKTYPE		'4'		/* Block special */
#define DIRTYPE		'5'		/* Directory */
#define FIFOTYPE	'6'		/* FIFO special */
#define CONTTYPE	'7'		/* Reserved */

/* Bits used in the mode field - values in octal */
#define TSUID		04000		/* Set UID on execution */
#define TSGID		02000		/* Set GID on execution */
#define TSVTX		01000		/* Reserved */
					/* File Permissions */
#define TUREAD		00400		/* read by owner */
#define TUWRITE		00200		/* write by owner */
#define TUEXEC		00100		/* execute/search by owner */
#define TGREAD		00040		/* read by group */
#define TGWRITE		00020		/* write by group */
#define TGEXEC		00010		/* execute/search by group */
#define TOREAD		00004		/* read by other */
#define TOWRITE		00002		/* write by group */
#define TOEXEC		00001		/* execute/search by other */

#endif _TAR_H
