/*	Copyright (c) 1984 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/
/* #ident	"@(#)head:unistd.h	1.5" */
  
/*
 *	This file originated from System V Release 2 source and has been
 * 	updated with defines required by POSIX 1003.1-1988 Std.
 */

#ifndef _UNISTD_H
#define _UNISTD_H

/* definition of NULL is needed for some files */
#ifndef NULL
#define NULL	0
#endif

/* Symbolic constants for the "access" routine: */
#define	F_OK		0	/* does file exist */
#define	X_OK		1	/* is it executable by caller */
#define	W_OK		2	/* writable by caller */
#define	R_OK		4	/* readable by caller */

#define	F_ULOCK		0	/* Unlock a previously locked region */
#define	F_LOCK		1	/* Lock a region for exclusive use */
#define	F_TLOCK		2	/* Test and lock a region for exclusive use */
#define	F_TEST		3	/* Test a region for other processes locks */

/* Symbolic constants for the "lseek" routine: */
#define	SEEK_SET	0	/* Set file pointer to "offset" */
#define	SEEK_CUR	1	/* Set file pointer to current plus "offset" */
#define	SEEK_END	2	/* Set file pointer to EOF plus "offset" */

/* Path names: */
#define	GF_PATH	"/etc/group"	/* Path name of the "group" file */
#define	PF_PATH	"/etc/passwd"	/* Path name of the "passwd" file */

/* Symbolic constants for the "sysconf" routine: */
#define	_SC_ARG_MAX		0	/* ARG_MAX */
#define	_SC_CHILD_MAX		1	/* CHILD_MAX */
#define	_SC_CLK_TCK		2	/* CLK_TCK */
#define	_SC_NGROUPS_MAX		3	/* NGROUPS_MAX */
#define	_SC_OPEN_MAX		4	/* OPEN_MAX */
#define	_SC_JOB_CONTROL		5	/* _POSIX_JOB_CONTROL */
#define	_SC_SAVED_IDS		6	/* _POSIX_SAVED_IDS */
#define	_SC_VERSION		7	/* _POSIX_VERSION */
#define	_SC_PID_MAX		8	/* PID_MAX */
#define	_SC_UID_MAX		9	/* UID_MAX */

/* Symbolic constants for the "pathconf" routine: */
#define	_PC_LINK_MAX		0	/* LINK_MAX */
#define	_PC_MAX_CANON		1	/* MAX_CANON */
#define	_PC_MAX_INPUT		2	/* MAX_INPUT */
#define	_PC_NAME_MAX		3	/* NAME_MAX */
#define	_PC_PATH_MAX		4	/* PATH_MAX */
#define	_PC_PIPE_BUF		5	/* PIPE_BUF */
#define	_PC_CHOWN_RESTRICTED	6	/* _POSIX_CHOWN_RESTRICTED */
#define	_PC_NO_TRUNC		7	/* _POSIX_NO_TRUNC */
#define	_PC_VDISABLE		8	/* _POSIX_VDISABLE */
#define	_PC_CHOWN_SUP_GRP	9	/* _POSIX_CHOWN_SUP_GRP */
#define	_PC_DIR_DOTS		10	/* _POSIX_DIR_DOTS */
#define	_PC_GROUP_PARENT	11	/* _POSIX_GROUP_PARENT */
#define	_PC_LINK_DIR		12	/* _POSIX_LINK_DIR */
#define	_PC_UTIME_OWNER		13	/* _POSIX_UTIME_OWNER */

/* POSIX feature definitions. */
#define _POSIX_JOB_CONTROL	1	/* Job control is provided */
#define	_POSIX_SAVED_IDS	1	/* Saved set-user-ID and set-group-ID */
#define	_POSIX_VERSION		198808L	/* Version of POSIX standard */
#define _POSIX_CHOWN_RESTRICTED 1	/* chown() is restricted */
#define _POSIX_NO_TRUNC		1	/* Pathname components are not truncated */
#define	_POSIX_VDISABLE		0	/* Value to disable tty special char */
/* #define _POSIX_CHOWN_SUP_GRP	??	/* chown() not limited to group set */
#define	_POSIX_DIR_DOTS		1	/* . and .. directory entries exist */
#define _POSIX_GROUP_PARENT	1	/* GID inhereted from parent dir */
#define _POSIX_LINK_DIR		1	/* link() of directory is supported */
#define	_POSIX_UTIME_OWNER	1	/* utime() permitted for file owner */

/* additions for stdio defines */
#define	STDIN_FILENO	0
#define STDOUT_FILENO	1
#define	STDERR_FILENO	2

#endif _UNISTD_H
