/* $Header: /nfs/europa/u1/BFMACH.local/mk/bfly2/RCS/ioconf.h,v 1.7 90/03/20 12:49:17 tappan Exp $ */
#ifndef	_MACHINE_IOCONF_H
#define	_MACHINE_IOCONF_H

#ifndef	ASSEMBLER
extern int (*VecTable[])();
#endif	ASSEMBLER

#define	VME_VEC		0	/* vectorized VME interrupt level */

/*
 * VMEbus device vector definitions for use by device
 * drivers in setting VMEbus vector registers.
 *
 * These values should match the vectorized interrupt
 * handlers defined in machine/conf.c VecTable.
 */
#define	HPS1_VEC	0x14	/* Systech Serial Line Adapter interrupt vec */
#define	HPS2_VEC	0x44	/* Systech Serial Line Adapter interrupt vec */
#define	XY1_VEC		0x17	/* Xylogics Disk VME interrupt vector */
#define	XY2_VEC		0x48	/* Xylogics Disk VME interrupt vector */
#define	DR_VEC		0x38	/* Ikon DR11-W VME interrupt vector */
#define	PLX_VEC		0x40	/* Parallax Graphics VME interrupt vector */
#define	EX_VEC		0x45	/* Excelan VME interrupt vector */
#define	DT1_VEC		0x60	/* Data Translations VME scan interrupt vec */
#define	DT2_VEC		0x61	/* Data Translations VME error interrupt vec */
#define EG_VEC		0x70	/* Interphase Eagle Ethernety controller */
#define	SHA_VEC		0xfe	/* Interphase SCSI VME interrupt vector */

/*
 * Number of possible VME interrupt vectors.
 */
#define VME_NUMVEC 256
#ifndef ASSEMBLER
/*
 * The vme_vec_table is a table of double word entries. The second word
 * of each entry is the VME interrupt handler address for this vector.
 * The first word is an optional argument for this device.
 * 
 * Note that the word ordering is required to keep register longword
 * alignment in the interrupt handler - see locore_vec.s.
 */
extern struct vme_vec_table {
	int arg;
	int (*handler)();
    } *my_vme_vec_table;

/*
 * The SetEnables_Table table in BUILD/ioconf.c defines which hardware
 * interrupt levels are enabled for each system interrupt level.
 */
extern u_short SetEnables_Table[];
#endif ASSEMBLER
#endif _MACHINE_IOCONF_H
