/* $Header: /nfs/columbia/u1/BFMACH.local/mk.gibson/bfly2/RCS/pcb.h,v 1.30 90/12/05 16:35:53 gibson Exp $ */
#if	CMU
/* 
 **********************************************************************
 * Mach Operating System
 * Copyright (c) 1986 Carnegie-Mellon University
 *  
 * This software was developed by the Mach operating system
 * project at Carnegie-Mellon University's Department of Computer
 * Science. Software contributors as of May 1986 include Mike Accetta, 
 * Robert Baron, William Bolosky, Jonathan Chew, David Golub, 
 * Glenn Marcy, Richard Rashid, Avie Tevanian and Michael Young. 
 * 
 * Some software in these files are derived from sources other
 * than CMU.  Previous copyright and other source notices are
 * preserved below and permission to use such software is
 * dependent on licenses from those institutions.
 * 
 * Permission to use the CMU portion of this software for 
 * any non-commercial research and development purpose is
 * granted with the understanding that appropriate credit
 * will be given to CMU, the Mach project and its authors.
 * The Mach project would appreciate being notified of any
 * modifications and of redistribution of this software so that
 * bug fixes and enhancements may be distributed to users.
 *
 * All other rights are reserved to Carnegie-Mellon University.
 **********************************************************************
 */
#endif	CMU
/*
 * Copyright (c) 1982, 1986 Regents of the University of California.
 * All rights reserved.  The Berkeley software License Agreement
 * specifies the terms and conditions for redistribution.
 *
 *	@(#)pcb.h	7.1 (Berkeley) 6/5/86
 */
#ifndef	_PCB_
#define	_PCB_

#ifdef	KERNEL
#include "../butterfly/pmap.h"
#else	KERNEL
#include <butterfly/pmap.h>
#endif	KERNEL

#include "../h/types.h"
#include "../butterfly/param.h"

/*
 * Butterfly-2 process control block
 */

struct pcb
{
	int	pcb_r0;
	int	pcb_r1;
	int	pcb_r2;
	int	pcb_r3;
	int	pcb_r4;
	int	pcb_r5;
	int	pcb_r6;
	int	pcb_r7;
	int	pcb_r8;
	int	pcb_r9;
	int	pcb_r10;
	int	pcb_r11;
	int	pcb_r12;
	int	pcb_r13;
	int	pcb_r14;
	int	pcb_r15; 
	int	pcb_r16; 
	int	pcb_r17; 
	int	pcb_r18; 
	int	pcb_r19; 
	int	pcb_r20; 
	int	pcb_r21;
	int	pcb_r22; 
	int	pcb_r23; 
	int	pcb_r24; 
	int	pcb_r25; 
	int	pcb_r26; 
	int	pcb_r27; 
	int	pcb_r28; 
	int	pcb_r29; 
	int	pcb_r30; 
	int	pcb_r31; 
#define pcb_msp pcb_r31
#ifdef	BFLY1
	int	pcb_pc; 		/* program counter */
#endif	BFLY1
#ifdef	BFLY2
	int	pcb_sxip;		/* execution pointers */
	int	pcb_snip;
	int	pcb_sfip;
#endif	BFLY2
	int	pcb_sr;
	struct {
		int fpsr;		/* floating point status register*/
		int fpcr;		/* floating point control register*/
	} pcb_fp_context;
	int	pcb_u_addr[UPAGES];	/* physical addresses of u area */
	unsigned long pcb_physaddr;
	st_entry_t	*pcb_virt_table;	/* virtual address of the root */
	root_ptr_t	pcb_root;	/* copy of reg pointing to seg table*/
/*
 * Software pcb (extension)
 */
	int	pcb_szpt; 	/* number of pages of user page table */
	int	pcb_my_cpu_active;
	int	*pcb_sswap;
	int	pcb_cpu_number;	/* previous/current cpu number */
	int	pcb_sigc[36];	/* size of sigcode for us */
};

void	pcb_init();
#endif	_PCB_
