/* $Header: /nfs/columbia/u1/BFMACH.local/mk/bfly2/RCS/scb.s,v 1.42 91/01/23 09:44:59 tappan Exp $ */
#if	CMU
/* 
 **********************************************************************
 * Mach Operating System
 * Copyright (c) 1986 Carnegie-Mellon University
 *  
 * This software was developed by the Mach operating system
 * project at Carnegie-Mellon University's Department of Computer
 * Science. Software contributors as of May 1986 include Mike Accetta, 
 * Robert Baron, William Bolosky, Jonathan Chew, David Golub, 
 * Glenn Marcy, Richard Rashid, Avie Tevanian and Michael Young. 
 * 
 * Some software in these files are derived from sources other
 * than CMU.  Previous copyright and other source notices are
 * preserved below and permission to use such software is
 * dependent on licenses from those institutions.
 * 
 * Permission to use the CMU portion of this software for 
 * any non-commercial research and development purpose is
 * granted with the understanding that appropriate credit
 * will be given to CMU, the Mach project and its authors.
 * The Mach project would appreciate being notified of any
 * modifications and of redistribution of this software so that
 * bug fixes and enhancements may be distributed to users.
 *
 * All other rights are reserved to Carnegie-Mellon University.
 **********************************************************************
 * HISTORY
 *
 *  1-Aug-88	jeff kenton	Butterfly-2
 *
 **********************************************************************
 */
 
#endif	CMU
/*
 * Copyright (c) 1982, 1986 Regents of the University of California.
 * All rights reserved.  The Berkeley software License Agreement
 * specifies the terms and conditions for redistribution.
 *
 *	@(#)scb.s	7.1 (Berkeley) 6/5/86
 */

#define	VEC(a)	or	r0, r0, 0	NEWLINEXXX \
		br	_X/**/a

#define	NO	or	r0, r0, 0	NEWLINEXXX \
		br	_Xreserved	NEWLINEXXX \

	global	_scb	/* _SCB defined in pnc.h */
_scb:	
	NO				;   0 -- reserved for RESET
	VEC(interrupt)			;   1 -- interrupt
	VEC(codaccess)			;   2 -- code access fault
	VEC(dataccess)			;   3 -- data access fault
	VEC(misaligned)			;   4 -- misaligned access
	VEC(opcode)			;   5 -- unimplemented opcode
	VEC(privilege)			;   6 -- privilege violation
	VEC(bounds)			;   7 -- bounds check trap
	VEC(divide)			;   8 -- integer divide error
	VEC(overflow)			;   9 -- integer ovcerflow
	VEC(error)			;  10 -- error trap

	NO NO NO NO NO NO NO NO NO NO	;  11 -  20
	NO NO NO NO NO NO NO NO NO NO	;  21 -  30
	NO NO NO NO NO NO NO NO NO NO	;  31 -  40
	NO NO NO NO NO NO NO NO NO NO	;  41 -  50
	NO NO NO NO NO NO NO NO NO NO	;  51 -  60
	NO NO NO NO NO NO NO NO NO NO	;  61 -  70
	NO NO NO NO NO NO NO NO NO NO	;  71 -  80
	NO NO NO NO NO NO NO NO NO NO	;  81 -  90
	NO NO NO NO NO NO NO NO NO NO	;  91 - 100
	NO NO NO NO NO NO NO NO NO NO	; 101 - 110
	NO NO NO			; 111 - 113

	VEC(fprecise)			; 114 -- floating precise exception
	VEC(fimprecise)			; 115 -- floating imprecise exception

		       NO NO NO NO NO	; 116 - 120  Unimplemented SFU's
	NO NO NO NO NO NO NO		; 121 - 127

	/*
	 * USER-INVOKABLE TRAPS (number>= 128):
	 *	When adding a user-callable trap, also record it
	 *	in fasttraps.h.
	 */
	VEC(syscall)			; 128 -- system call trap
	VEC(udb_bkpt)			; 129 -- breakpoint (adb or kdb)
	VEC(fasttrap)			; 130 -- get trap timings

	VEC(getusecclock)		; 131 -- map vaddr to paddr
	VEC(get64bitclock)		; 132 -- get 64-bit real time clock
	VEC(getphysaddr)		; 133 -- map vaddr to paddr
	NO				; 134 -- was getposixclock
	VEC(panic_bkpt)			; 135 -- panic breakpoint

	VEC(vm_cache_flush)		; 136 -- user access to cmmu commands
	VEC(vm_codecache_flush)		; 137 -- as above but for code cmmu
	VEC(mmu_line_flush)		; 138 -- even faster for lines
	VEC(code_mmu_line_flush)	; 139 -- as above but for code cmmu
	VEC(btransfer)			; 140 -- bulk data transfer via cache
	VEC(trap10)			; 141 -- fasttrap: user_sleep_and_unlock, user_wakeup
	VEC(trap11)			; 142 -- fasttrap: user gist event logging
	NO				; 143 -- Was OEM feature 1 interface
	VEC(getpaddrinfo)		; 144 -- map between mbus/tbus
	            NO NO NO NO NO	; 145 - 149

		; 150-170 -- User access to atomic ops (implemented
		; 		using augmentations.
	VEC(usr_atomic_call)		; 150 -- generic call
	VEC(usr_atomic_xmem_16)		; 151 -- atomically xmem short
	VEC(usr_atomic_cta_8)		; 152 -- 8-bit clear-then-add
	VEC(usr_atomic_cta_16)		; 153 -- 16-bit clear-then-add
	VEC(usr_atomic_cta_32)		; 154 -- 32-bit clear-then-add
	VEC(usr_atomic_cas_32)		; 155 -- 32-bit compare-and-swap
	VEC(usr_atomic_CAS2_32)		; 156 -- 32-bit two-way comp-and-swap
	VEC(usr_atomic_ff0_and_set_8)	; 157 -- 8-bit find first 0 and set
	VEC(usr_atomic_ff0_and_set_16)	; 158 -- 16-bit find first 0 and set
	VEC(usr_atomic_ff0_and_set_32)	; 159 -- 32-bit find first 0 and set
	VEC(usr_atomic_ff1_and_clear_8)	; 160 -- 8-bit find first 1 and clear
	VEC(usr_atomic_ff1_and_clear_16); 161 -- 16-bit find first 1 and clear
	VEC(usr_atomic_ff1_and_clear_32); 162 -- 32-bit find first 1 and clear

	      NO NO NO NO NO NO NO NO	; 163 - 170 -- USER ATOMIC OPS 
	NO NO NO NO NO NO NO NO NO NO	; 171 - 180 -- USER ATOMIC OPS

	NO NO NO NO NO NO NO NO NO NO	; 181 - 190
	NO NO NO NO NO NO NO NO NO NO	; 191 - 200

	NO NO NO NO NO NO NO NO NO NO	; 201 - 210
	NO NO NO NO NO NO NO NO NO NO	; 211 - 220
	NO NO NO NO NO NO NO NO NO NO	; 221 - 230
	NO NO NO NO NO NO NO NO NO NO	; 231 - 240
	NO NO NO NO NO NO NO NO NO NO	; 241 - 250
	NO NO NO NO NO NO NO NO NO NO	; 251 - 260
	NO NO NO NO NO NO NO NO NO NO	; 261 - 270
	NO NO NO NO NO NO NO NO NO NO	; 271 - 280
	NO NO NO NO NO NO NO NO NO NO	; 281 - 290
	NO NO NO NO NO NO NO NO NO NO	; 291 - 300

	NO NO NO NO NO NO NO NO NO NO	; 301 - 210
	NO NO NO NO NO NO NO NO NO NO	; 311 - 320
	NO NO NO NO NO NO NO NO NO NO	; 321 - 330
	NO NO NO NO NO NO NO NO NO NO	; 331 - 340
	NO NO NO NO NO NO NO NO NO NO	; 341 - 350
	NO NO NO NO NO NO NO NO NO NO	; 351 - 360
	NO NO NO NO NO NO NO NO NO NO	; 361 - 370
	NO NO NO NO NO NO NO NO NO NO	; 371 - 380
	NO NO NO NO NO NO NO NO NO NO	; 381 - 390
	NO NO NO NO NO NO NO NO NO NO	; 391 - 400

	NO NO NO NO NO NO NO NO NO NO	; 401 - 410
	NO NO NO NO NO NO NO NO NO NO	; 411 - 420
	NO NO NO NO NO NO NO NO NO NO	; 421 - 430
	NO NO NO NO NO NO NO NO NO NO	; 431 - 440
	NO NO NO NO NO NO NO NO NO NO	; 441 - 450
	NO NO NO NO NO NO NO NO NO NO	; 451 - 460
	NO NO NO NO NO NO NO NO NO NO	; 461 - 470
	NO NO NO NO NO NO NO NO NO NO	; 471 - 480
	NO NO NO NO NO NO NO NO NO NO	; 481 - 490
	NO NO NO NO NO NO NO NO NO NO	; 491 - 500

	NO NO				; 501 - 502
	      VEC(DivByZeroTrap)	; 503 - Motorola workaround for Divide-By-Zero errata
	         NO NO NO NO NO NO NO	; 504 - 510
	NO				; 511
