/* $Header: useraug.h,v 1.2 89/09/25 18:57:25 gibson Exp $ */
/*****************************************************************************
* Header file supporting user traps to do atomic operations via
* augmentations.
******************************************************************************/

/* Subcodes distinguishing different user-accessible atomic operations	*/
/* This list must match uaug_operation_table in useraug.c		*/
/* Furthermore, some operations may rely on the conventions that 	*/
/* a: the 8/16/32 operations should be 	in that order and		*/
/* b) they should be consecutive					*/

#define	USERAUG_CALL			0
#define	USERAUG_XMEM_16			1
#define	USERAUG_CTA_8			2
#define	USERAUG_CTA_16			3
#define	USERAUG_CTA_32			4
#define	USERAUG_CAS_32			5
#define	USERAUG_CAS2_32			6
#define	USERAUG_FF0_AND_SET_8	        7
#define	USERAUG_FF0_AND_SET_16	        8
#define	USERAUG_FF0_AND_SET_32	        9
#define	USERAUG_FF1_AND_CLEAR_8	       10
#define	USERAUG_FF1_AND_CLEAR_16       11
#define	USERAUG_FF1_AND_CLEAR_32       12

/* Result codes for user augmentation utility routines */
#define	USERAUG_SUCCESS			1
#define	USERAUG_FAILURE			2
#define	USERAUG_PAGEDOUT		3	/* Transitory error: Retry */
