/* $Header: /nfs/europa/u1/BFMACH.local/mk/bflyc/RCS/bitmap_c.h,v 1.1 90/11/09 13:27:31 tappan Exp $ */


#ifdef KERNEL
#ifndef __BITMAP_C_H
#define __BITMAP_C_H yes

/*
 * Definitions for operations on bitmaps
 */
typedef unsigned bitmap_element_t;
typedef int bitnum_t;

typedef struct {
    bitmap_element_t *map;	/* pointer to bit array */
    bitnum_t limit;		/* maximum bit number */
    unsigned size;		/* Size of array in 'unsigned's */
} bitmap_data_t, *bitmap_t;

#define NOBIT (bitnum_t)-1

/*
 * Map to convert bit number to a mask
 */
extern unsigned BitsLE[];	/* Little endian bits */
extern unsigned BitsBE[];	/* Big endian bits */

/*
 * bits in a bitmap are processed big endian
 */

/*
 * Map to convert bit field width to a mask
 */
extern unsigned Widths[];

#ifdef __STDC__
bitnum_t findzerobit(bitmap_t); /* return highest order 0 bit or -1 */
bitnum_t findonebit(bitmap_t);	/* return highest order 1 bit or -1 */
void setonebit(bitmap_t, bitnum_t);
void clearonebit(bitmap_t,  bitnum_t);
bitnum findbitrange(bitmap_t, int size);
void setbitrange(bitmap_t, bitnum_t, int);
void clearbitrange(bitmap_t, bitnum_t, int);

 /* create bitmap of given size (in bits) 
  * The third argument is '1' to initialize the map to 1, or 'zero' 
  * to set it to zero.
  *
  * Returns '1' if successful, else 0.
  */
int create_bitmap(bitmap_t, int, int);
#else
extern bitnum_t findzerobit();
extern bitnum_t findonebit();
extern void setonebit();
extern void clearonebit();
extern bitnum_t findbitrange();
extern void setbitrange();
extern void clearbitrange();

extern int create_bitmap();
#endif /* __STDC__ */

#endif /* __BITMAP_C_H */
#endif /* KERNEL */
