/* $Header: /nfs/columbia/u1/BFMACH.local/mk.gibson/bflyc/RCS/genassym.c,v 1.74 91/02/08 12:17:48 gibson Exp $	*/
#if	CMU
/* 
 **********************************************************************
 * Mach Operating System
 * Copyright (c) 1986 Carnegie-Mellon University
 * All other rights are reserved to Carnegie-Mellon University.
 **********************************************************************
 */
#endif	CMU

#include </usr/include/stdio.h>

/*
 * This definition is used to get structure padding right in cross-compilation
 * environment.
 */
#define	KERNEL_GENASSYM	1

#include "cs_generic.h"
/*
 * Copyright (c) 1982, 1986 Regents of the University of California.
 * All rights reserved.  The Berkeley software License Agreement
 * specifies the terms and conditions for redistribution.
 *
 *	@(#)genassym.c	7.1 (Berkeley) 6/5/86
 */

#include "../h/param.h"
#include "../h/vmparam.h"

#include "../h/user.h"

#include "../h/buf.h"
#include "../h/proc.h"
#include "../h/callout.h"
#include "../h/queue.h"
#include "../h/sched.h"
#include "../h/signal.h"
#include "../vm/vmi.h"

#ifdef BFLY1
#include "../machine/frame.h"
#endif BFLY1
#include "../machine/pmap.h"
#include "../machine/signali.h"
#ifdef BFLY1
#include "../machine/reg.h"
#endif BFLY1

#include "../h/disklabel.h"
#include "../butterflydev/mbvar.h"
#include "../butterflydev/mbreg.h"
#include "../butterflydev/xyreg.h"

#include "../machine/bitmap.h"

#include "../h/socket.h"
#include "../net/if.h"
#include "../net/route.h"
#include "../netinet/in.h"
#include "../netinet/in_pcb.h"
#include "../netinet/in_systm.h"
#include "../netinet/in_var.h"
#include "../netinet/ip.h"
#include "../netinet/ip_var.h"
#include "../netinet/ip_icmp.h"
#include "../netinet/tcp.h"

#include "../rpc/types.h"
#include "../rpc/xdr.h"
#include "../rpc/auth.h"
#include "../rpc/clnt.h"
#include "../nfs/nfs_chtable.h"

main()
{
	struct bootinfo *bootinfo = (struct bootinfo *)0;
	struct pcb *pcb_p = (struct pcb *)0;
	struct proc *p = (struct proc *)0;
	struct sigtramp_args *sta = (struct sigtramp_args *)0;
	struct sigtramp_regs *str = (struct sigtramp_regs *)0;
	struct sigcontext *scp = (struct sigcontext *)0;
	struct user *up = (struct user *)0;

	/*	Booting		*/
#ifdef BFLY2
	printf("#define\tBOOT_PC %d\n", &bootinfo->boot_pc);
	printf("#define\tBOOT_ROOT %d\n", &bootinfo->boot_root);
#endif BFLY2

	/*	Callout Stuff	*/
	if (sizeof (callout_info_t) > MAX_CALLOUT_INFO_SIZE) {
		fprintf (stderr, "ERROR: sizeof (callout_info_t) is %d bytes",
			sizeof (callout_info_t));
		fprintf (stderr, " (legal maximum is %d!)\n",
			MAX_CALLOUT_INFO_SIZE);
		exit (10);
	}

	/*	Context-switching	*/
	printf("#define\tUPAGES %d\n", UPAGES);
#ifdef BFLY1
	/* Register layout in u.u_ar0 frame */
	{
		int	*locr0 = (int *)0;

		printf("#define\tXF_TCargs %d\n", &locr0[TC_ARGS]);
		printf("#define\tXF_TClocals %d\n", &locr0[TC_LOCALS]);
		printf("#define\tXF_EXCBASE %d\n", &locr0[EXCBASE]);

		/* args */
		printf("#define\tXF_TCCODE %d\n", &locr0[TCCODE]);
		printf("#define\tXF_TCTYPE %d\n", &locr0[TCTYPE]);

		/* locals */
		printf("#define\tXF_TIMEVAL %d\n", &locr0[TIMEVAL1]);
		printf("#define\tXF_RTE_EXCEPT %d\n", &locr0[RTE_EXCEPT]);
		printf("#define\tXF_SAVED_EXCEPT %d\n", &locr0[SAVED_EXCEPT]);

		/* saved copies of pre-trap registers */
		printf("#define\tXF_D0 %d\n", &locr0[D0]);
		printf("#define\tXF_SP %d\n", &locr0[SP]);
		printf("#define\tXF_PC %d\n", &locr0[PC]);
		printf("#define\tXF_SR %d\n", &locr0[SR]);
	}
	/* 68881/2 Floating Point Chip */
	{
		struct fp_context *fpc = (struct fp_context *)0;

		printf("#define\tFP_STATE 0x%x\n", &fpc->fp_state[0]);
		printf("#define\tFP_REGS 0x%x\n", &fpc->fp_regs[0]);
		printf("#define\tFP_CR 0x%x\n", &fpc->fp_cr);
	}
#endif BFLY1

	/*	Memory Management	*/
	printf("#define\tVM_PAGESHIFT %d\n", VM_PAGESHIFT);
	printf("#define\tVM_PAGESIZE 0x%x\n", VM_PAGESIZE);
	printf("#define\tVM_PAGEMASK 0x%x\n", VM_PAGEMASK);
	printf("#define\tPTE_SIZE %d\n", sizeof(pt_entry_t));
	printf("#define\tNBPG %d\n", NBPG);
	printf("#define\tPGOFSET %d\n", PGOFSET);
#ifdef BFLY2
	printf("#define\tDATA_MMU 0x%x\n", DATA_MMU);
	printf("#define\tCODE_MMU 0x%x\n", CODE_MMU);
	printf("#define\tCODE_MMU2 0x%x\n", CODE_MMU2);
	printf("#define\tMMU_PG_INVALID %d\n", MMU_PG_INVALID);
	printf("#define\tMMU_PG_TYPE %d\n", MMU_PG_TYPE);
	printf("#define\tMMU_PG_CACHABLE_TYPE %d\n", MMU_PG_CACHABLE_TYPE);
	printf("#define\tMMU_PG_CB_CACHABLE_TYPE %d\n",
		MMU_PG_CB_CACHABLE_TYPE);

	printf("#define\tMMUPTE_SIZE 0x%x\n", sizeof(mmu_pt_entry_t));
	printf("#define\tCMMU_USRPROBEBITS 0x%x\n", CMMU_USRPROBEBITS);
	printf("#define\tCMMU_PTE_WP %d\n", CMMU_PTE_WP);
	printf("#define\tCMMU_PROBE_UADDR 0x%x\n", CMMU_PROBE_UADDR);
	printf("#define\tCMMU_SSR_V 0x%x\n", CMMU_SSR_V);
	/* mmu_info will be allocated on stack, so round up size. */
#define	ALIGN_STACK_MASK	0x7
	printf("#define\tALIGNED_MMU_INFO_SIZE 0x%x\n",
	       (sizeof(struct mmu_info)+ALIGN_STACK_MASK) & ~ALIGN_STACK_MASK);
#endif BFLY2

	/* Address space constants */
#ifdef BFLY2	/* $$$ resolve some other time why BFLY2 and not BFLY1 */
	printf("#define\tKTEXT_SEG_OFFSET 0x%x\n", KTEXT_SEG_OFFSET);
	printf("#define\tUAREA_SEG_OFFSET 0x%x\n", UAREA_SEG_OFFSET);
	printf("#define\tFE_SEG_OFFSET 0x%x\n", FE_SEG_OFFSET);
#endif BFLY2
	printf("#define\tUSER_MAX_VADDR 0x%x\n", USER_MAX_VADDR);
#ifdef BFLY2	/* $$$ resolve some other time why BFLY2 and not BFLY1 */
	printf("#define\tKERNEL_STACK_VADDR 0x%x\n", KERNEL_STACK_VADDR);
	printf("#define\tU_AREA_VADDR 0x%x\n", U_AREA_VADDR);
	printf("#define\tPHYS_MAP_VADDR 0x%x\n", PHYS_MAP_VADDR);
#endif BFLY2
	printf("#define\tU_AREA_STPAGE_VADDR 0x%x\n", U_AREA_STPAGE_VADDR);
#ifdef BFLY1
	printf("#define\t_BOOTINFO_BASE 0x%x\n", _BOOTINFO_BASE);
#endif BFLY1
	printf("#define\tINTSTACK_SIZE 0x%x\n", INTSTACK_SIZE);
	
	/*	PCB Structure	*/
	printf("#define\tPCB_CPU_NUMBER %d\n", &pcb_p->pcb_cpu_number);
	printf("#define\tPCB_FP_CONTEXT %d\n", &pcb_p->pcb_fp_context);
	printf("#define\tPCB_MSP %d\n", &pcb_p->pcb_msp);
	printf("#define\tPCB_ROOT %d\n", &pcb_p->pcb_root);
#ifdef BFLY1
	printf("#define\tPCB_ATOMIC_PB %d\n", &pcb_p->pcb_atomic_pb);
	printf("#define\tPCB_PC %d\n", &pcb_p->pcb_pc);
#endif BFLY1
#ifdef BFLY2
	printf("#define\tPCB_R0 %d\n", &pcb_p->pcb_r0);
	printf("#define\tPCB_SXIP %d\n", &pcb_p->pcb_sxip);
#endif BFLY2
	printf("#define\tPCB_SIGC %d\n", &pcb_p->pcb_sigc[0]);
	printf("#define\tPCB_SIZE %d\n", sizeof (struct pcb));
	printf("#define\tPCB_SR %d\n", &pcb_p->pcb_sr);
	printf("#define\tPCB_U_ADDR %d\n", pcb_p->pcb_u_addr);
	printf("#define\tPCB_VIRT_TABLE %d\n", &pcb_p->pcb_virt_table);

	/*	Proc Structure	*/
	if (sizeof(struct proc) != PROC_SIZE_REQUIRED) {
		fprintf(stderr, "ERROR: sizeof(struct proc) must be %d\n",
			PROC_SIZE_REQUIRED);
		fprintf(stderr, "sizeof(struct proc) is currently %d\n",
		       sizeof(struct proc));
		fprintf(stderr, 
	"The results of any subsequent assemblies will be useless...\n");
		exit(9);
	}
	printf("#define\tP_PCB %d\n", &p->p_pcb);
	printf("#define\tP_RECOVER %d\n", &p->p_recover);

	/*	U Struct	*/
	printf("#define\tU_AR0 (_u+%d)\n", &up->u_ar0);
	printf("#define\tU_ERROR_USER (_u_user+%d)\n", &up->u_error);
	printf("#define\tU_PROCP %d\n", &up->u_procp);

	/*	Scheduler	*/
	printf("#define\tRQ_SIZE %d\n", sizeof (struct run_queue));

	/*	Simple lock Stuff	*/
	printf("#define\tSIMPLE_LOCK_SIZE %d\n", sizeof (simple_lock_data_t));
	printf("#define\tSIMPLE_LOCK 0x%x\n", SIMPLE_LOCK);

	/*	Signal structures used by signal trampoline code (sigcode) */
	printf("#define\tSTARGS_SIZE 0x%x\n", sizeof(struct sigtramp_args));
	printf("#define\tSTA_SIGNUM 0x%x\n", &sta->sta_signum);
	printf("#define\tSTA_CODE 0x%x\n", &sta->sta_code);
	printf("#define\tSTA_SCP 0x%x\n", &sta->sta_scp);
	printf("#define\tSTA_HANDLER 0x%x\n", &sta->sta_handler);

	printf("#define\tSTREGS_SIZE 0x%x\n", sizeof(struct sigtramp_regs));
#ifdef BFLY1
	printf("#define\tSTR_fp0 0x%x\n", &str->str_fp0);
	printf("#define\tSTR_fpcr 0x%x\n", &str->str_fpcr);
	printf("#define\tSTR_d0 0x%x\n", &str->str_d0);
#endif BFLY1
#ifdef BFLY2
	printf("#define\tSTR_fpcr 0x%x\n", &str->str_fpcr);
	printf("#define\tSTR_fpsr 0x%x\n", &str->str_fpsr);
	printf("#define\tSTR_r1 0x%x\n", &str->str_r1);
	printf("#define\tSTR_r3 0x%x\n", &str->str_r3);
	printf("#define\tSTR_r4 0x%x\n", &str->str_r4);
	printf("#define\tSTR_r6 0x%x\n", &str->str_r6);
	printf("#define\tSTR_r8 0x%x\n", &str->str_r8);
	printf("#define\tSTR_r10 0x%x\n", &str->str_r10);
	printf("#define\tSTR_r12 0x%x\n", &str->str_r12);
#endif BFLY2
	
#ifdef BFLY1
	printf("#define\tSCP_FPSTATE 0x%x\n", scp->_scm_fpstate);
#endif BFLY1
	printf("#define\tHSYNCHTYPE_DEFAULT %d\n", HSYNCHTYPE_DEFAULT);

	/*	Virtual Memory Stuff	*/
	printf("#define\tVM_IHASH_SIZE %d\n", sizeof (vm_ihash_data_t));


	/*      IP              */
	printf("#define IFQUEUE_SIZE %d\n", sizeof(struct ifqueue));
	printf("#define IPQ_SIZE %d\n", sizeof(struct ipq));
	printf("#define INPCB_SIZE %d\n", sizeof(struct inpcb));

#ifdef BFLY2
	/*	Hardware I/O	*/
	printf("#define\tVIRT_IACK_BLOCK %d\n", VIRT_IACK_BLOCK);
#endif BFLY2

	/*	Xylogics Driver	*/
	printf("#define\tUNITINFO_SIZE %d\n", sizeof (UNITINFO));
	printf("#define\tPART_INFO_SIZE %d\n", sizeof (PART_INFO));
	printf("#define\tNPARTITIONS %d\n", NPARTITIONS);
	printf("#define\tIOPB450_SIZE %d\n", sizeof (struct iopb450));
	printf("#define\tIOPB_CNT %d\n", IOPB_CNT);
	printf("#define\tIOPBQ_SIZE %d\n", sizeof(IOPBQ));
	printf("#define\tIOCTL_BUF_SIZE %d\n", IOCTL_BUF_SIZE);
	printf("#define\tBUF_SIZE %d\n", sizeof (struct buf));
	printf("#define\tMDR_DMA %d\n", MDR_DMA);
	printf("#define\tXYQUEUEHEAD_SIZE %d\n", sizeof (QUEUE));
	printf("#define\tMPQUEUE_HEAD_SIZE %d\n",sizeof (struct mpqueue_head));

	/* NFS client data size */
	printf("#define CHTAB_SIZE %d\n", sizeof(struct chtab)*MAXCLIENTS);

	/* bitmap data structure header */
	printf("#define BITMAP_HEADER_SIZE %d\n", sizeof(bitmap_data_t));
}
