/* $Header: /nfs/europa/u1/BFMACH.local/mk/bflyc/RCS/gistdefs_c.h,v 1.15 90/12/07 13:34:34 lkaplan Exp $ */
/*****************************************************************************
* File: gistdefs.h - Kernel event-logging for use with the GIST program      *
*                                                                            *
* Started 2/28/88 by drb                                                     *
* Major Revision 3/89 by drb and rwells                                      *
* Triggering features 7/89 by drb and rwells                                 *
*****************************************************************************/

#ifndef _GISTDEFS_
#define _GISTDEFS_

#include "gist.h"
#if GIST
#ifdef BFLY1
#include "../butterfly/pnc.h"
#endif BFLY1
#ifdef BFLY2
#include "../butterfly/b2vme.h"
#endif BFLY2

typedef struct 
	{
	long	rtc_value;
	long	event_code;
	long	event_data;
	} EVENT;

extern EVENT *gist_pointer;
extern EVENT *gist_buffer;
extern EVENT *gist_limit;
extern EVENT *gist_trigpt;
extern int gist_level;
extern int gist_trigoffs;

#define ELOG(level,code,data)\
{\
if ((gist_level | ELOG_TRIGGER_LEVEL)&(level)) \
   gist_elog(level,code,data); \
}

/* These define the "standard" event classes */

#define ELOG_FAULT_LEVEL         0x00000001
#define ELOG_SYSCALL_LEVEL       0x00000002
#define ELOG_SCHED_LEVEL         0x00000004
#define ELOG_PID_LEVEL           0x00000008
#define ELOG_IO_LEVEL            0x00000010
#define ELOG_SIGNAL_LEVEL        0x00000020
#define ELOG_SWTCH_LEVEL         0x00000040
#define ELOG_USU_LEVEL           0x00000080
#define ELOG_TLB_LEVEL           0x00000100
#define ELOG_INACT_LEVEL         0x00000200
#define ELOG_CLOCK_LEVEL         0x00000400
#define ELOG_TOP_LEVEL           0x00000800
#define ELOG_LOCK_LEVEL		 0x00001000

/* These define a few "Software Logic Analyzer" features; bits stolen */
/* from the gist_level space, so beware                               */

#define ELOG_HISTOGRAM_LEVEL     0x10000000
#define ELOG_CIRCULAR_LEVEL      0x20000000
#define ELOG_TRIGGER_LEVEL       0x40000000 
#define ELOG_SPLITPID_LEVEL      0x80000000

/* These define a few event classes for experiments            */
/* NO ELOG MACROS MENTIONING THESE CLASSES SHOULD END UP IN MK */

#define ELOG_T1_LEVEL            0x01000000
#define ELOG_T2_LEVEL            0x02000000
#define ELOG_T3_LEVEL            0x04000000
#define ELOG_T4_LEVEL            0x08000000
#define ELOG_T5_LEVEL            0x00100000
#define ELOG_T6_LEVEL            0x00200000
#define ELOG_T7_LEVEL            0x00400000
#define ELOG_T8_LEVEL            0x00800000

#include "gistpoints.h"

#define ELOG_PID(level) \
{\
if((gist_level&(level))&&(gist_level&ELOG_PID_LEVEL))\
    gist_elog (ELOG_PID_LEVEL, ELOG_PID_POINT, u.u_procp->p_pid); \
}   

#else 
/* This so we can leave ELOG's around but turned off... */
#define ELOG(level,code,data)
#define ELOG_PID(level)
#endif GIST

#endif _GISTDEFS_
