/****************************************************************************
* File: cimt.h -  SCSI Cipher 1/2 inch Tape definitions                     *
*****************************************************************************/

/* drive mode setup templates.  Please refer to the tapedrive manual		*/

typedef struct
	{
	unsigned char command;
	unsigned lun:3;
	unsigned res0:5;
	unsigned char res1;
	unsigned char res2;
	unsigned char paramlen;
	unsigned res3:6;
	unsigned flag:1;
	unsigned link:1;
	} CI_MODE1;

#define CI_MODE1_NBYTES 6


typedef struct
	{
	unsigned char res0;
	unsigned char res1;
	unsigned res2:1;
	unsigned bufmode:3;
	unsigned speed:4;
	unsigned char blkdesclen;
	unsigned res3:4;
	unsigned density:4;
	unsigned char numblks[3];
	unsigned char res4;
	unsigned char bsize[3];
	unsigned char vendpagecode;
	unsigned char addpagelen;
	unsigned res5:7;
	unsigned rdew:1;
	} CI_MODE2;

#define CI_MODE2_NBYTES 16 /* round up to the next word size */

#define CI_LOW_DENSITY 0x02
