/* $Header: /nfs/gemini/u1/BFMACH.local/mk/butterflydev/RCS/vlpreg.h,v 1.1 90/03/29 12:35:23 uban Exp $ */

#ifndef	_VLPREG_H
#define	_VLPREG_H

/*
 * File: vlpreg.h
 * Definitions for the VMEbus loopback device.
 *
 * March 28, 1989 Thomas W. Uban
 *
 * Copyright 1989 by BBN Advanced Computers Inc.
 * ALL RIGHTS RESERVED
 *
 * No part of this material may be reproduced, stored in a retrieval
 * system, transmitted or used in any form or by any means, electronic,
 * mechanical, photocopying, recording, or otherwise, without the prior
 * written permission of, or express license from BBN Advanced
 * Computers Inc.
 *
 * RESTRICTED RIGHTS LEGEND
 *
 * Use, duplication, or disclosure by the Government is subject to
 * restrictions as set forth in subparagraph (c)(1)(ii) of the Rights
 * to Technical Data and Computer Software clause at DFARS 52.227-7013.
 *
 * BBN Advanced Computers Inc.
 * 10 Fawcett Street
 * Cambridge, Ma. 02238
 * 617-873-6000
 */

#ifdef	KERNEL
/*
 * VMEbus loopback software status per interface.
 */
struct	vlp_softc {
    short	xs_flags;	  /* flag information */
    int		xs_lnode;	  /* logical node where device lives */
    caddr_t	xs_rawbuf;	  /* virtual addr of raw data buffer */
    u_long	xs_rawbuf_busaddr;/* bus address of raw data buffer */
    struct	mb_device *xs_md; /* pointer to device information */
    simple_lock_data_t xs_lock;	  /* multiprocessor lock */
};

/*
 * xs_flags definitions.
 */
#define	VLP_ALIVE	0x0001	/* device is alive */
#define	VLP_OPEN	0x0002	/* someone has the device opened */

/*
 * General definitions.
 */
#define	VLP_SIZE	8000	/* size of loopback buffer (page - softc) */

#endif	KERNEL
#endif	_VLPREG_H
