/* $Header: /nfs/columbia/u1/BFMACH.local/mk.2.9.6/butterflydev/RCS/xyreg.h,v 1.34 91/03/14 19:26:41 gibson Exp $ */
/*
 * This Include file contains the misc definitions used in Xylogic's UNIX
 *	device Drivers.
 */

#ifndef	LOCORE
/* Driver Defined Data Types */

typedef unsigned char	UCHAR, BYTE, BOOL;
typedef unsigned int	UINT;
typedef unsigned long	ULONG;
typedef unsigned char   *BYTEPTR;
typedef unsigned int	*UINTPTR;
typedef unsigned long   *ULONGPTR;
typedef int		INT;
typedef struct buf	BUF, *BUFPTR;
typedef struct buf	IOBUF, *IOBUFPTR;	/*from xenix*/

/* Driver Defined Storage Classes */

#define GLOBAL	extern
#define LOCAL   static

/* Bit Definitions */

#define	BIT0	0x01
#define	BIT1	0x02
#define	BIT2	0x04
#define	BIT3	0x08
#define	BIT4	0x10
#define	BIT5	0x20
#define	BIT6	0x40
#define	BIT7	0x80

/* Boolean Definitions */

#define BAD	0
#define CLEAR   0
#define NORETRY 0

#define GOOD	1
#define SET	1
#define RETRY	1

#define NOT     !


/*
 * The flags field in mb_device structure is used for drive type in
 * xylogics controller.  Only the first two bits are used since the range
 * for drive types is limited to 0 - 3.
 */
#define DTMASK 0x3		/* drive type mask */


/*
	Driver Confuguration Constants
*/

#define RETRY_CNT	15
#define splXY		splbio	/* Driver Interrupt Lockout Priority */

/*
	IOPB byte 0 Masks
*/

	/* Commands => bits 0-3 */

#define NOP		0x0	
#define Write		0x1
#define Read		0x2
#define W_Track_Hdr	0x3
#define R_Track_Hdr	0x4
#define Seek		0x5
#define Drv_Reset	0x6
#define Wrt_Format	0x7
#define Rd_H_D_E	0x8
#define Rd_Drv_Stat	0x9
#define Wrt_H_D_E	0xa
#define Set_Drv_Size	0xb
#define Self_Test	0xc
#define Reserved	0xd
#define Buff_Fill	0xe
#define Buff_Dump	0xf

#define IEN	BIT4
#define CHEN	BIT5
#define RELO	BIT6
#define AUD	BIT7


/*
	IOPB byte 1 Masks
*/

	/* ECC Modes => Bits 0-1 */

#define ECM0	0x0
#define ECM1	0x1
#define ECM2	0x2
#define ECM3	0x3

#define EEF	BIT2	/* Enable Extended functions */
#define ASR	BIT3	/* Auto Seek Retry
#define HDP	BIT4	/* Hold Dual Port Drive */
#define IERR	BIT5	/* Interrupt on Error */
#define IEI	BIT6	/* Interrupt on each IOPB */

/*
	IOPB byte 2 Masks 
*/

#define	XYLOGICS450	BIT2

/*
	IOPB byte 4 Masks 
*/

	/* Throttle => bits 0-2 */

#define THROT0 		0x0		/* 2 DMA cycles */
#define THROT1 		0x1		/* 4 DMA cycles */
#define THROT2 		0x2		/* 8 DMA cycles */
#define THROT3 		0x3		/* 16 DMA cycles */
#define THROT4 		0x4		/* 32 DMA cycles */
#define THROT5 		0x5		/* 64 DMA cycles */
#define THROT6 		0x6		/* 128 DMA cycles */
#define THROT7 		0x7		/* 256 DMA cycles */


	/* Interleave Factor => bits 3-6 */

#define	INTERLEAVE_1	0x0		/* 1:1 RATIO */
#define	INTERLEAVE_2	0x8		/* 2:1 RATIO */
#define	INTERLEAVE_3	0x10		/* 3:1 RATIO */
#define	INTERLEAVE_4	0x18		/* 4:1 RATIO */
#define	INTERLEAVE_5	0x20		/* 5:1 RATIO */
#define	INTERLEAVE_6	0x28		/* 6:1 RATIO */
#define	INTERLEAVE_7	0x30		/* 7:1 RATIO */
#define	INTERLEAVE_8	0x38		/* 8:1 RATIO */
#define	INTERLEAVE_9	0x40		/* 9:1 RATIO */
#define	INTERLEAVE_A	0x48		/* 10:1 RATIO */
#define	INTERLEAVE_B	0x50		/* 11:1 RATIO */
#define	INTERLEAVE_C	0x58		/* 12:1 RATIO */
#define	INTERLEAVE_D	0x60		/* 13:1 RATIO */
#define	INTERLEAVE_E	0x68		/* 14:1 RATIO */
#define	INTERLEAVE_F	0x70		/* 15:1 RATIO */
#define INTERLEAVE_10	0x78		/* 16:1 ratio */

#define WORD_MODE 	0x0	/* Word DMA transfer */
#define BYTE_MODE 	0x80	/* Byte DMA transfer */

/*
 *	This include file contains all the Constant Masks used to
 *	find the STATUS of the Driver, Controller or a particular
 *	unit attached to the Controller.
 */

		/* IOPB STATUS */

		/* Status Byte 1 */

#define IOPB_ERR	BIT7	/* set when error occured during Iopb exec. */
#define IOPB_DONE 	BIT0	/* set when Iopb has completed */

		/* Status byte 2 */
#define Success		0x0	/* successful completion */
#define Intr_Pend	0x1	/* Interrupt Pending error */
#define Busy_Conf	0x2	/* Busy conflict Error */
#define Timeout		0x3	/* Operation timeout error */
#define Hdr_Not_Found	0x5	/* Header not found error */
#define Hard_ECC	0x6	/* Hard ECC error */
#define Ill_Cyl_Addr	0x7	/* Illegal cylinder address error */
#define Ill_Sect_Addr	0xa	/* Illegal sector address error */
#define Last_Sect_Sm	0xd	/* Last sector to small error */
#define Slave_ACK	0xe	/* Slave ACK error */
#define Cyl_Hd_Hdr	0x12	/* Cylinder and Head header error */
#define Seek_Retry	0x13	/* Seek retry required */
#define Wrt_Protect	0x14	/* Write protect error */
#define Unimpl_Cmd	0x15	/* Unimplimented command error */
#define Drv_Not_Rdy	0x16	/* Drive not ready error */
#define Sect_Cnt_0	0x17	/* Sector Count zero error */
#define Drv_Fault	0x18	/* Drive fault error */
#define Ill_Sect_Sz	0x19	/* Illegal sector size error */
#define SelfA		0x1a	/* Self test A failure */
#define SelfB		0x1b	/* Self test B failure */
#define SelfC		0x1c	/* Self test C failure */
#define Soft_ECC	0x1e	/* Soft ECC error */
#define Soft_ECC_Rec	0x1f	/* Soft ECC recovered */
#define Ill_Hd_Addr	0x20	/* Illegal Head address Error */
#define Disk_Seq	0x21	/* Disk sequencer error */
#define Seek_Err	0x25	/* Seek error */

	/* Byte 'A' for READ DRIVE STATUS */

#define DISK_FAULT	BIT2	/* Disk fault */
#define SEEK_ERR	BIT3	/* Hard Seek error */
#define DP_BUSY		BIT4	/* Dual port busy */
#define WRT_PROTECT	BIT5	/* Disk write protect */
#define DRVNOTRDY	BIT6	/* Drive not ready */
#define OFF_CYL		BIT7	/* OFF cylinder */

	/* Byte '10' for HDOFST option */
#define EHDT		BIT6	/* Extended Header Drive Type */
#define ESD		BIT7	/* Enable embedded servo drive */
	/* CONTROLLER STATUS  */

/*	Controller Status Register 	*/

#define CSR_DREADY	BIT0	/* Set at Drive Reset to Indicate Ready-on cylinder status		*/

#define CSR_AACK	BIT1	/* Set by Controller to Acknowledge a request				*/

#define CSR_AREQ	BIT2	/* Set by Driver to get Controller's Attention				*/

#define CSR_24BIT	BIT3	/* Set by Controller if Stapled for 24 bit addressing 			*/

#define CSR_IPND	BIT4	/* Set by Controller when it Completes an IOPB and issues an Interrupt	*/

#define CSR_DERR	BIT5	/* Set by Controller when a Double error condition occurs		*/

#define CSR_ERR		BIT6	/* Set by Controller when a General error condition occurs		*/

#define CSR_BUSY	BIT7	/* Set by Driver, reset by Controller					*/

#define CSR_GO		BIT7	/* Set by Driver to Start an idle 	Controller 			*/

	/* 	DRIVER STATUS	*/

	/* Unitinformation Status  */

#define U_ONLINE	BIT0	/* Set if Selected unit is ONLINE */

#define U_OVERLAP	BIT1	/* Set if Selected Unit supports Overlapped seeks */

	/* Partition Status - from xy_sts[][]  */

#define P_ABSENT	0	/* Partition is ABSENT */

#define P_PRESENT 	1	/* Partition is PRESENT  but not OPENED */

#define P_OPEN		2	/* Partition is PRESENT and OPENED  */

#define P_LOCKED	3	/* Partition should not be ACCESSED */


	/* BUF Queue Header Status - iobuf->b_active	*/

#define	xy_BUSY	BIT0	/* Set by Driver When it hits the */
				/* Controllers Go Bit, Reset by   */
				/* Driver when the Controller goes */
				/* IDLE 			*/

#define ATTN_REQ	BIT1	/* Set by driver when it Sets the */
				/* AREQ Bit in the Controllers CSR */
				

#define ATTN_ACK	BIT2	/* Set by Driver when the Controller */
				/* ACKNOWLEDGES A REQUEST	*/


/*
 *
 *	This include file contains the definitions of the IOPB Structure
 *	used in this Unix driver for Xylogics 450 Disk Controller.
 *
 */

#define	IOPB_SIZE	24	/* Number of bytes in an IOPB */

/*
	IOPB STRUCTURE INFORMATION
*/
typedef struct iopb450  *IOPBPTR;

typedef struct iopb450 {
	BYTE	 byte[IOPB_SIZE];	/* Information bytes */
	BYTE	todo[8];		/* for mapped sectors ... */
	int	alreadydone;		/* count of I/O successfully completed */
	IOPBPTR  forward;		/* Forward Queue Pointer */
	IOPBPTR  back;			/* Back Queue Pointer */
	BUFPTR 	 buffer;		/* Pointer to Buf Structure */
} IOPB;


/*
	Iopb 'byte' Address Offsets
*/

#define	COMM		0x0	/* Command Byte */
#define IMODE		0x1	/* Interrupt Mode/Function Mod byte */
#define STAT1		0x2	/* Status byte 1 */
#define STAT2		0x3	/* Status byte 2 */
#define THROT		0x4	/* Throttle byte */
#define DRIVE		0x5	/* Drive type/unit select */
#define HEAD		0x6	/* HEAD byte */
#define SECT		0x7	/* Sector byte */
#define CYLL		0x8	/* Cylinder addrell low byte */
#define CYLH		0x9	/* Cylinder address high byte */
#define SCNTL		0xa	/* Sector count low byte */
#define SCNTH		0xb	/* Sector count high byte */
#define DATAL		0xc	/* Data address low byte */
#define DATAH		0xd 	/* Data address high byte */
#define DATARL		0xe	/* Data relocation low byte */
#define DATARH		0xf	/* Data relocation high byte */
#define HDOFST		0x10	/* Head offset byte */
#define RES		0x11	/* Reserved byte */
#define NIOPBL		0x12	/* Next Iopb address low byte */
#define NIOPBH		0x13	/* Next Iopb address high byte */
#define ECCMH		0x14	/* ECC pattern High BYTE */
#define ECCML		0x15	/* ECC pattern low byte */
#define ECCAL		0x16    /* ECC Offset low byte */
#define ECCAH		0x17	/* ECC Offset high byte */

/*
 *	This Include file contains the Structure Definition for the
 *	IOPB/BUF queues for the UNIX Driver for the Xylogics CONTROLLER
 */

typedef struct iopb_queue {
	IOPBPTR	forward;
	IOPBPTR back;
	int	status;
} IOPBQ;

typedef IOPBQ	*IOPBQP;

typedef struct queue_head {
	IOPBQP active;		/* Pointer to head of ACTIVE Queue */
	IOPBQP ready;		/* Pointer to head of READY  Queue */
} QUEUE;

/* special flags found in the buffer field of iopb's */
#define IOPB_WANTED	1	/* process waiting for free iopb (free queue) */
#define IOPB_BUSY	2	/* xylogics card is busy (active queue) */

/*
	PARTITION INFORMATION STRUCTURE DEFINITION
*/

typedef struct part_info {
	unsigned int   p_offset;	/* Starting sector of partition */
	unsigned int   p_len;		/* Number of sectors in the partition */
} PART_INFO;


/*
 *	Xylogic's Model 450 Disk Controller I/O Register Structure
 *	Definition
 */

/* Model 450 and 451 Controller Register Definition */

typedef struct reg {
	BYTE	reloc_low;		/* Iopb Relocation low byte */
	BYTE 	reloc_high;		/* Iopb Relocation high byte */
	BYTE 	addr_low;		/* Iopb Address low byte */
	BYTE 	addr_high;		/* Iopb Address high byte */
	BYTE	csr;			/* Controller Status Register */
	BYTE 	crur;			/* Controller Reset/Update Register */
} CONTROLLER;

#define RELOC_LOW	0
#define RELOC_HIGH	1
#define ADDR_LOW	2
#define ADDR_HIGH	3
#define CSR		4
#define CRUR		5

/*
	UNIT INFORMATION STRUCTURE DEFINITION - One per Drive
*/
typedef struct unitinformation {
	BYTE name[128];		  /* device name string */
	short drive_type;	  /* drive type */
	short status;		  /* unit status */
	struct mb_device *device; /* device struct */
	short heads;		  /* surfaces per drive */
	short cylinders;	  /* cylinders per surfaces */
	short sectors;		  /* sectors per surface (minus spares) */
	short trk_spares;		
	short interleave;         /* Interleave Factor */
	short sect_size;	  /* bytes per sector */
} UNITINFO;

typedef struct sect {
	unsigned short cyl;
	unsigned short head;
	unsigned short sect;
} SECTOR;

/* WARNING - IOCTLBUF_SIZE should always be a even multiple of sizeof(int) */
#define IOCTL_BUF_SIZE	520	/* size of special buffer for ioctl calls */
#define DEFECT_SIZE 	24	/* size of defect info */

#endif	LOCORE

#define NCOPYBUF 20

#ifndef	LOCORE
#define IOPB_CNT	24
#endif	LOCORE
