#! /bin/sh
# $Id: newvers.rel.sh,v 1.1 91/01/19 11:25:54 rschaaf Exp $
#
# Generate 'vers.c' for a release kernel
#
DATE=`/bin/date`
HOST=`/bin/hostname`
WHO=`whoami`
PWD=`pwd`
CONFIG_NAME=`basename $PWD`
RELEASE_LEVEL="2.9.7"
verfile="VERSION"
case $1 in 
	BFLY2|tc2000)
		OS="nX Operating System"
		;;
	BFLY1|gp1000)
		OS="Mach 1000"
		;;
	*)
		echo "Unknown operating system"
		OS="????"
		;;
esac

if [ -f $verfile ] ; then
	VERSION=`cat $verfile`
	VERSION=`expr $VERSION + 1`
else
	VERSION=1
fi
rm -f $verfile
echo $VERSION > $verfile

cat <<EOF
static char copyright[] = "/* \\n\\
 **********************************************************************\\n\\
 * Mach Operating System\\n\\
 * Copyright (c) 1986 Carnegie-Mellon University\\n\\
 *  \\n\\
 * This software was developed by the Mach operating system\\n\\
 * project at Carnegie-Mellon University's Department of Computer\\n\\
 * Science. Software contributors as of May 1986 include Mike Accetta, \\n\\
 * Robert Baron, William Bolosky, Jonathan Chew, David Golub, \\n\\
 * Glenn Marcy, Richard Rashid, Avie Tevanian and Michael Young. \\n\\
 * \\n\\
 * Some software in these files are derived from sources other\\n\\
 * than CMU.  Previous copyright and other source notices are\\n\\
 * preserved below and permission to use such software is\\n\\
 * dependent on licenses from those institutions.\\n\\
 * \\n\\
 * Permission to use the CMU portion of this software for \\n\\
 * any non-commercial research and development purpose is\\n\\
 * granted with the understanding that appropriate credit\\n\\
 * will be given to CMU, the Mach project and its authors.\\n\\
 * The Mach project would appreciate being notified of any\\n\\
 * modifications and of redistribution of this software so that\\n\\
 * bug fixes and enhancements may be distributed to users.\\n\\
 *\\n\\
 * All other rights are reserved to Carnegie-Mellon University.\\n\\
 **********************************************************************\\n\\
 * HISTORY\\n\\
 **********************************************************************\\n\\
 */ \\n\\
";
char version[] = "$OS $RELEASE_LEVEL ($CONFIG_NAME) #$VERSION: $DATE\n";
EOF

