/* $Header: /nfs/europa/u1/BFMACH.local/mk/conf/RCS/param.c,v 1.26 91/02/01 16:36:05 lkaplan Exp $ */
#if	CMU
/* 
 **********************************************************************
 * Mach Operating System
 * Copyright (c) 1986 Carnegie-Mellon University
 *  
 * This software was developed by the Mach operating system
 * project at Carnegie-Mellon University's Department of Computer
 * Science. Software contributors as of May 1986 include Mike Accetta, 
 * Robert Baron, William Bolosky, Jonathan Chew, David Golub, 
 * Glenn Marcy, Richard Rashid, Avie Tevanian and Michael Young. 
 * 
 * Some software in these files are derived from sources other
 * than CMU.  Previous copyright and other source notices are
 * preserved below and permission to use such software is
 * dependent on licenses from those institutions.
 * 
 * Permission to use the CMU portion of this software for 
 * any non-commercial research and development purpose is
 * granted with the understanding that appropriate credit
 * will be given to CMU, the Mach project and its authors.
 * The Mach project would appreciate being notified of any
 * modifications and of redistribution of this software so that
 * bug fixes and enhancements may be distributed to users.
 *
 * All other rights are reserved to Carnegie-Mellon University.
 **********************************************************************
 */
#endif	CMU

#include "sun_quota.h"
/*
 * Copyright (c) 1980, 1986 Regents of the University of California.
 * All rights reserved.  The Berkeley software License Agreement
 * specifies the terms and conditions for redistribution.
 *
 *	@(#)param.c	7.1 (Berkeley) 6/5/86
 */

#ifndef lint
char copyright[] =
"@(#) Copyright (c) 1980, 1986 Regents of the University of California.\n\
 All rights reserved.\n";
#endif not lint

#include "../h/param.h"
#include "../h/systm.h"
#include "../h/socket.h"
#include "../h/user.h"
#include "../h/proc.h"
#include "../h/time.h"
#include "../h/vnode.h"
#include "../ufs/inode.h"
#include "../h/file.h"
#include "../h/callout.h"
#include "../h/clist.h"
#include "../h/cmap.h"
#include "../h/mbuf.h"
#include "../ufs/quota.h"
#include "../specfs/fifo.h"
#include "../h/kernel.h"
#ifdef	butterfly
#include "cpus.h"
#endif	butterfly
#include "inet.h"

/*
 * System parameter formulae.
 *
 * This file is copied into each directory where we compile
 * the kernel; it should be modified there to suit local taste
 * if necessary.
 *
 * Compiled with -DHZ=xx -DTIMEZONE=x -DDST=x -DMAXUSERS=xx
 */

#define	HZ 100

int	syshz = HZ;		/* written into vectorized hz at boot time */
int	tick = 1000000 / HZ;
int	tickadj = 240000 / (60 * HZ);		/* can adjust 240ms in 60s */
struct	timezone tz = { TIMEZONE, DST };

#ifdef	butterfly
#define NPROCPERNODE 64
		/* = 1 page */
#define	NPROC NPROCPERNODE * 6
int	maxuprc = 50 + 16*NCPUS;
int	nprocpernode = NPROCPERNODE;
/* defined in machine/param_c.h */
int	maxprocper4megnode = MAXPROCPER4MEGNODE;
int	maxprocper16megnode = MAXPROCPER16MEGNODE;
#else	butterfly
#define	NPROC (20 + 8 * MAXUSERS)
#endif	butterfly

int	nproc = NPROC;

#define	NRNODE 128
int	maxrnode = NRNODE;
int     ncsize = (NPROC + 16 + MAXUSERS) + 32; /* name cache size */

/* maxinodepernode is used to calculate a maximum for active inodes.
 * if this limit is exceeded, then garbage collection is more aggressive
 */
int maxinodepernode = 50;

#ifdef	butterfly
int	nfile = 10240;
#else	butterfly
int	nfile = 16 * (NPROC + 16 + MAXUSERS) / 10 + 32;
int	ncallout = 16 + NPROC;
#endif	butterfly

int	nclist = 60 + 12 * MAXUSERS;
#if	SUN_QUOTA
int	ndquot = (MAXUSERS * NMOUNT) / 4 + NPROC;
#endif

#if INET
#define NETSLOP 20			/* for all the lousy servers*/
#else
#define NETSLOP 0
#endif

/*
 * These are initialized at bootstrap time
 * to values dependent on memory size
 */
int	nbuf, nswbuf;

/*
 * These have to be allocated somewhere; allocating
 * them here forces loader errors if this file is omitted
 * (if they've been externed everywhere else; hah!).
 */
struct	proc *proc, *procNPROC;
struct	fileq file;
struct	cblock *cfree;
struct	buf *buf, *swbuf;
char	*buffers;
struct	cmap *cmap, *ecmap;
struct	namecache *namecache;
#if	SUN_QUOTA
struct	dquot *dquot, *dquotNDQUOT;
#endif
/* initialize SystemV named-pipe (and pipe()) information structure */
struct fifoinfo fifoinfo = {
	FIFOBUF,
	FIFOMAX,
	FIFOBSZ,
	FIFOMNB
};
