/* assert.h */
#ifndef BBN_ASSERT
#include "bbn_assert.h"
#endif

#if BBN_ASSERT
extern int assert_enable;
#define	REAL_ASSERT(mask,cond,printfargs,dopanic) \
	if ((assert_enable & (mask)) && !(cond) ) { \
	    printf("Assertion failed line %d file %s\n",__LINE__,__FILE__); \
	    printf printfargs; \
	    if (dopanic) \
		    panic("assertion failed"); \
	} 
#else BBN_ASSERT
#define REAL_ASSERT(mask,cond,printfargs,dopanic)	{}
#endif BBN_ASSERT

#define ASRT_MISC	0x00000001
#define ASRT_SCHED	0x00000002
#define ASRT_PROC	0x00000004
#define ASRT_LOCK	0x00000008
#define ASRT_MEM	0x00000010

#define ASSERT(c)	   REAL_ASSERT(ASRT_MISC,(c),("assertion failed\n"),1)
#define LOCK_ASSERT(c,v)   REAL_ASSERT(ASRT_LOCK,(c),("lock at 0x%x\n",v),1)
