
/*ACI:  $Header: exec.h,v 1.5 89/11/11 12:06:43 cdh Exp $       */
/*
 *      File:   exec.h
 *
 *      Copyright (C) 1989, BBN Advanced Computers
 *
*/

/* Version for new object file format with multiple, named segments. */

#ifndef _EXEC_
#define _EXEC_

/*
 * object file header
 */

struct exec {
  unsigned char		a_filetype;	/* file attributes */
  unsigned char		a_machtype;	/* machine type, os type */
  unsigned short	a_magic;	/* magic number */
  unsigned long		a_text;		/* size of text segment */
  unsigned long		a_data;		/* size of initialized data */
  unsigned long		a_bss;		/* size of uninitialized data */
  unsigned long		a_syms;		/* size of symbol table */
  unsigned long		a_entry;	/* entry point */
  unsigned long		a_trsize;	/* size of text relocation */
  unsigned long		a_drsize;	/* size of data relocation */
};

/* magic numbers */

#define	OMAGIC	0407			/* old impure format (assembly output and kernel) */
#define	NMAGIC	0410			/* read-only text (obselete, not used) */
#define	ZMAGIC	0413			/* demand load format (most executables) */

/* machine types */

#define M_MASK		0xf		/* Mask for machine type in machtype */
#define M_NULL		0		/* null value */
#define M_68010		1		/* 68000/68010 */
#define M_68020		2		/* 68020/68030 */
#define M_88100		8		/* 88100 */

/* OS types */

#define OS_MASK		0xf0		/* Maks for OS type in machtype */
#define OS_NULL		0		/* Null value */
#define OS_SUN	        0		/* Sun OS */
#define OS_CHRYS	0x80		/* Chrysalis */
#define OS_MACH		0x90		/* MACH-1000 or MACH-2000 */
#define OS_PSOS		0xa0		/* pSOS or pSOS+ */

/* Machine+OS types */

#define M_SUN2          (M_68010 | OS_SUN)
#define M_SUN3          (M_68020 | OS_SUN)
#define M_OLDSUN2	0		/* Old Sun-2 executable files */

#define M_GP1000	(M_68020 | OS_MACH)
#define M_TC2000	(M_88100 | OS_MACH)
#define M_RT1000	(M_68020 | OS_PSOS)
#define M_RT2000	(M_88100 | OS_PSOS)
#define M_CHRYS		(M_68020 | OS_CHRYS)

/* file types (bit mask) */

#define F_NULL		0		/* null value */
#define F_SEGS		1		/* segment table present */
#define F_DYNAMIC	2		/* dynamically linked */

#endif _EXEC_
