/* $Header: msgbuf.h,v 1.6 89/10/31 14:08:57 gibson Exp $ */
#if	CMU
/* 
 ************************************************************************
 * Mach Operating System
 * Copyright (c) 1986 Carnegie-Mellon University
 *  
 * This software was developed by the Mach operating system
 * project at Carnegie-Mellon University's Department of Computer
 * Science. Software contributors as of May 1986 include Mike Accetta, 
 * Robert Baron, William Bolosky, Jonathan Chew, David Golub, 
 * Glenn Marcy, Richard Rashid, Avie Tevanian and Michael Young. 
 * 
 * Some software in these files are derived from sources other
 * than CMU.  Previous copyright and other source notices are
 * preserved below and permission to use such software is
 * dependent on licenses from those institutions.
 * 
 * Permission to use the CMU portion of this software for 
 * any non-commercial research and development purpose is
 * granted with the understanding that appropriate credit
 * will be given to CMU, the Mach project and its authors.
 * The Mach project would appreciate being notified of any
 * modifications and of redistribution of this software so that
 * bug fixes and enhancements may be distributed to users.
 *
 * All other rights are reserved to Carnegie-Mellon University.
 ************************************************************************
 */
 
#endif	CMU
/*
 * Copyright (c) 1982, 1986 Regents of the University of California.
 * All rights reserved.  The Berkeley software License Agreement
 * specifies the terms and conditions for redistribution.
 *
 *	@(#)msgbuf.h	7.1 (Berkeley) 6/4/86
 */

#include	"../h/lock.h"

#define	MSG_MAGIC	0x063065
/*
 * A struct msgbuf consists of a header and a circular buffer.  For some
 * reason I didn't want to research, the size of the whole structure should
 * be 4096, so we use the trick with the union to cause that to happen.
 */
struct	msgbuf {
	union {
		/* The real structure, except msg_bufc is much bigger */
		struct _msgbuf {
			long			_msg_magic;
			long			_msg_bufx;
			long			_msg_bufr;
			simple_lock_data_t	_msg_buflock;
			short			_msg_lastnode;
			short			_msg_atnewline;
			char			_msg_bufc[1]; /* actual data */
		} _msgbuf;

		/* dummy  to establish total structure size */
		char	_msgbuf_space[4096];
	} _msgu;
};

#define	msg_magic	_msgu._msgbuf._msg_magic
#define	msg_bufx	_msgu._msgbuf._msg_bufx
#define	msg_bufr	_msgu._msgbuf._msg_bufr
#define	msg_buflock	_msgu._msgbuf._msg_buflock
#define	msg_bufc	_msgu._msgbuf._msg_bufc
#define	msg_lastnode	_msgu._msgbuf._msg_lastnode
#define	msg_atnewline	_msgu._msgbuf._msg_atnewline

	/* Amount of structure used for header */
#define	MSG_BUFC_OFFSET	((unsigned)(((struct msgbuf *)0)->msg_bufc))
	/* Amount left over for data */
#define	MSG_BSIZE	(sizeof(struct msgbuf) - MSG_BUFC_OFFSET)

#ifdef KERNEL

#define	NODETAG_SIZE	11	/* length of processor "tag" on each line */

extern struct	msgbuf msgbuf;

#define	LOGLOCK(spl)	{ 					\
	spl = splhigh();						\
	simple_lock(&msgbuf.msg_buflock);				\
}

#define	LOGUNLOCK(spl)	{					\
	simple_unlock(&msgbuf.msg_buflock);				\
	splx(spl);							\
}


#endif
