/* $Header: multio.h,v 1.4 90/02/08 08:39:08 rgoguen Exp $ */

#ifndef _MULTIO_H
#define _MULTIO_H
/*****************************************************************************
File:     multio.h
Contents: Definitions for multread and multwrite
System:   MACH 1000

Remarks:  

Copyright 1989 by BBN Advanced Computers Inc.
ALL RIGHTS RESERVED

No part of this material may be reproduced, stored in a retrieval
system, transmitted or used in any form or by any means, electronic,
mechanical, photocopying, recording, or otherwise, without the prior
written permission of, or express license from BBN Advanced Computers Inc.

RESTRICTED RIGHTS LEGEND

Use, duplication, or disclosure by the Government is subject to
restrictions as set forth in subparagraph (c)(1)(ii) of the Rights to
Technical Data and Computer Software clause at DFARS 52.227-7013.

BBN Advanced Computers Inc.
10 Fawcett Street
Cambridge, Ma. 02238
617-873-6000
*****************************************************************************/

struct multio 
{
    int     fd;	    	/* file descriptor */
    off_t   offset;	/* file starting offset */
    caddr_t	base;	/* process starting address */
    int	    len;	/* desired transfer length */
    int     ret_len;	/* OUT: actual transfer length */
    int     ret_errno;	/* OUT: errno, if ret_len is -1 */
};

typedef struct multio *multio_t;

struct multio_ret_buf {
    int     ret_len;	/* actual transfer length */
    int     ret_errno;	/* errno, if ret_len is -1 */
    caddr_t    b_addr;  /* starting virtual address of pages to unwire.*/
    long    b_bcount;   /* number of bytes to unwire.*/
};

#define MULTIO_ORDERED   0x00000001	/* Do in order, wait, abort on error */
#define MULTIO_UNORDERED 0x00000002	/* Do any order, wait till all done */

#define MULTIO_MASK 3

#if defined(__STDC__) || defined(c_plusplus)
extern int multread(int option, multio_t ptr, int count);
extern int multwrite(int option, multio_t ptr, int count);
#else
extern int multread();
extern int multwrite();
#endif

#ifdef KERNEL
#define MULTIO_MAGIC 0x43653221
#define REQUEST_IS_MULTIO(bp) ((bp)->b_flags & B_MULTIO)
#endif KERNEL

#endif _MULTIO_H
