/* $Header: /nfs/europa/u1/BFMACH.local/mk/h/RCS/procinfo.h,v 1.1 90/09/24 21:28:38 rschaaf Exp $ */

#ifndef _PROCINFO_
#define _PROCINFO_

struct pi_list {
	int	pi_field;	/* Identifier for field of interest */

	int	pi_len;		/*  0 ==> value to be returned in pi_value  */
				/* >0 ==> value to be returned in buffer of */
			        /*        size pi_len bytes that is pointed */
				/*        to by pi_value                    */
				/* For a successful indirect store, this    */
				/* field is set to the actual number of     */
				/* bytes stored.                            */

	int	pi_value;	/* pi_len == 0: Used to return value of the */
				/*        corresponding field               */
				/* pi_len > 0: Store the value of the       */
				/*        corresponding field indirectly    */
				/*        through the pointer stored in     */
				/*        pi_value.                         */

	int	pi_retcode;     /*  0 ==> success                           */
				/* <0 ==> error                             */
                                /*        error codes defined in errno.h    */
				/* EINVAL - Requested field not supported,  */
				/*          or pi_len < 0.                  */
				/* EACCES - Field access permission denied  */
				/* EFAULT - Fault occurred when storing     */
				/*          indirect through pi_value       */
				/* E2BIG  - Value to big to return in the   */
				/*          supplied buffer.  The size      */
				/*          needed is returned in pi_len.   */
};

/* Field identifiers */
#define PI_NOENTRY		    0   /* Indicates end of field list */
#define PI_STAT			    1	/* Process state */
     /* Values for PI_STAT field */
#    define PI_STAT_SSLEEP	1
#    define PI_STAT_SWAIT	2
#    define PI_STAT_SRUN	3
#    define PI_STAT_SIDL	4
#    define PI_STAT_SZOMB       5
#    define PI_STAT_SSTOP       6
#    define PI_STAT_SGANGSTOP	7

#define PI_HOME_CLUSTER_ID	    2	/* Cluster ID */
#define PI_HOME_NODE		    3	/* Home node (system logical node #) */
#define PI_ISTRACED		    4   /* Non-zero value indicates process  */
					/* is being traced.                  */

#endif  _PROCINFO_
