/* $Header: /nfs/europa/u1/BFMACH.local/mk/h/RCS/reboot.h,v 1.14 90/06/29 14:34:56 lkaplan Exp $ */

#ifndef reboot_h
#define reboot_h
/* 
 **********************************************************************
 * Mach Operating System
 * Copyright (c) 1986 Carnegie-Mellon University
 *  
 * All other rights are reserved to Carnegie-Mellon University.
 **********************************************************************
 */

#ifdef	KERNEL
#include "cs_kdb.h"
#include "cputypes.h"
#else	KERNEL
#include <sys/features.h>
#endif	KERNEL

/*
 * Copyright (c) 1982, 1986 Regents of the University of California.
 * All rights reserved.  The Berkeley software License Agreement
 * specifies the terms and conditions for redistribution.
 *
 *	@(#)reboot.h	7.1 (Berkeley) 6/4/86
 *      @(#)reboot.h    2.2 88/05/26 4.0NFSSRC SMI;
 */

/*
 * Arguments to reboot system call.
 * These are passed to boot program in r11,
 * and on to init.
 */
#define	RB_AUTOBOOT	0	/* flags for system auto-booting itself */

#define	RB_ASKNAME	0x01	/* ask for file name to reboot from */
#define	RB_SINGLE	0x02	/* reboot to single user only */
#if	CS_KDB
#define RB_KDB		0x04	/* load kernel debugger */
#endif	CS_KDB
#define	RB_HALT		0x08	/* don't reboot, just halt */
#define	RB_INITNAME	0x10	/* name given for /etc/init */
#define	RB_DFLTROOT	0x20	/* use compiled-in rootdev */
#define	RB_NOSYNC	0x40	/* dont sync before reboot */
#define RB_WRITABLE     0X100   /* MOUNT FILESYSTEM WRITABLE */

#define	RB_PANIC	0	/* reboot due to panic */
#define	RB_BOOT		1	/* reboot due to boot() */

/*
 * Constants for converting boot-style device number to type,
 * adaptor (uba, mba, etc), unit number and partition number.
 * Type (== major device number) is in the low byte
 * for backward compatibility.  Except for that of the "magic
 * number", each mask applies to the shifted value.
 */
#define	B_ADAPTORSHIFT	24
#define	B_ADAPTORMASK	0x0f
#define B_UNITSHIFT	16
#define B_UNITMASK	0xff
#define B_PARTITIONSHIFT 8
#define B_PARTITIONMASK	0xff
#define	B_TYPESHIFT	0
#define	B_TYPEMASK	0xff
#define	B_MAGICMASK	0xf0000000
#define	B_DEVMAGIC	0xa0000000

#ifdef	BFLY1
#define SECBOOT_GOOD 0x12345678

typedef struct {
	short flags;
	short nbufs;
	} BOOTCONFIG;
#endif	BFLY1

#ifdef	BFLY2
#define SECBOOT_GOOD 0x89abcdef

typedef struct {
	short flags;
	short nbufs;
 	short iobusid;
	} BOOTCONFIG;

#define	NO_IOBUSID	-1
#define MAX_IOBUSID	31	/* maximum allowable iobusid */
#endif BFLY2

#define BOOT_NONE	0x0	/* leave node alone	*/
#define BOOT_MACH	0x01	/* flag says boot MACH 	*/
#define BOOT_PSOS	0x02	/* pSOS			*/
#define BOOT_BUFS	0x04	/* says buffers were configured */
#define BOOT_INTRLVD	0x08	/* include node in interleaving pool */
#define BOOT_PUBLIC	0x10	/* put node into public cluster */

#endif reboot_h
