/*	$Header: /nfs/columbia/u1/BFMACH.local/mk.gibson/h/RCS/signal.h,v 1.20 91/02/12 20:35:43 gibson Exp $							*/
#ifndef _SIGNAL_H
#define _SIGNAL_H
/* 
 **************************************************************************
 * Mach Operating System
 * Copyright (c) 1986 Carnegie-Mellon University
 *  
 * This software was developed by the Mach operating system
 * project at Carnegie-Mellon University's Department of Computer
 * Science. Software contributors as of May 1986 include Mike Accetta, 
 * Robert Baron, William Bolosky, Jonathan Chew, David Golub, 
 * Glenn Marcy, Richard Rashid, Avie Tevanian and Michael Young. 
 * 
 * Some software in these files are derived from sources other
 * than CMU.  Previous copyright and other source notices are
 * preserved below and permission to use such software is
 * dependent on licenses from those institutions.
 * 
 * Permission to use the CMU portion of this software for 
 * any non-commercial research and development purpose is
 * granted with the understanding that appropriate credit
 * will be given to CMU, the Mach project and its authors.
 * The Mach project would appreciate being notified of any
 * modifications and of redistribution of this software so that
 * bug fixes and enhancements may be distributed to users.
 *
 * All other rights are reserved to Carnegie-Mellon University.
 **************************************************************************
 */

#ifdef	KERNEL
#include "../h/posix.h"
#ifdef BFLY1
#include "../machine/fpu.h"
#endif BFLY1
#else	KERNEL
#include <sys/posix.h>
#include <sys/features.h>
#ifdef BFLY1
#include <machine/fpu.h>
#endif BFLY1
#endif	KERNEL

/*
 * Copyright (c) 1982, 1986 Regents of the University of California.
 * All rights reserved.  The Berkeley software License Agreement
 * specifies the terms and conditions for redistribution.
 *
 *	@(#)signal.h	7.1 (Berkeley) 6/4/86
 */

#ifndef	NSIG
#define NSIG	32

#define	SIGHUP	1	/* hangup */
#define	SIGINT	2	/* interrupt */
#define	SIGQUIT	3	/* quit */
#define	SIGILL	4	/* illegal instruction (not reset when caught) */

	/* codes for SIGILL */
#ifdef BFLY1
#define	    ILL_ADDRESS_FAULT	0x0c	/* address error 	     */
#define     ILL_ILLINSTR_FAULT  0x10    /* illegal instruction fault */
#define     ILL_PRIVVIO_FAULT   0x20    /* privilege violation fault */
#define     ILL_COPROCERR_FAULT 0x34    /* [coprocesser protocol error fault] */
#define     ILL_TRAP0_FAULT     0x80    /* trap #0 fault */
#define     ILL_TRAP1_FAULT     0x84    /* trap #1 fault */
#define     ILL_TRAP2_FAULT     0x88    /* trap #2 fault */
#define     ILL_TRAP3_FAULT     0x8c    /* trap #3 fault */
#define     ILL_TRAP5_FAULT     0x94    /* trap #5 fault */
#define     ILL_TRAP6_FAULT     0x98    /* trap #6 fault */
#define     ILL_TRAP7_FAULT     0x9c    /* trap #7 fault */
#define     ILL_TRAP8_FAULT     0xa0    /* trap #8 fault */
#define     ILL_TRAP9_FAULT     0xa4    /* trap #9 fault */
#define     ILL_TRAP10_FAULT    0xa8    /* trap #10 fault */
#endif BFLY1
#ifdef BFLY2
#define	    ILL_OPCODE_FAULT	5	/* unimplemented opcode fault */
#define     ILL_PRIVVIO_FAULT   6    	/* privilege violation fault */
#define     ILL_TRAP_FAULT	511     /* reserved trap fault */
#endif BFLY2

/* CHME, CHMS, CHMU are not yet given back to users reasonably */
#define	SIGTRAP	5	/* trace trap (not reset when caught) */
#define	SIGIOT	6	/* IOT instruction */
#define	SIGABRT	SIGIOT	/* compatibility */
#define	SIGEMT	7	/* EMT instruction */

#ifdef BFLY1
#define     EMT_EMU1010         0x28    /* line 1010 emulator trap */
#define     EMT_EMU1111         0x2c    /* line 1111 emulator trap */
#endif BFLY1

#define	SIGFPE	8	/* floating point exception */

	/* codes for SIGFPE */
#ifdef BFLY1
#define     FPE_INTDIV0		0x14	/* Integer divide by zero    */
#define     FPE_CHKINST_TRAP	0x18	/* CHK or CHK2 instruction */
#define     FPE_TRAPV_TRAP      0x1c    /* TRAPV [cpTRAPcc TRAPcc] instr */
#define     FPE_FLTBSUN_TRAP    0xc0    /* [branch or set on unordered cond] */
#define     FPE_FLTINEX_TRAP    0xc4    /* [floating inexact result] */
#define     FPE_FLTDIV_TRAP     0xc8    /* [floating divide by zero] */
#define     FPE_FLTUND_TRAP     0xcc    /* [floating underflow] */
#define     FPE_FLTOPERR_TRAP   0xd0    /* [floating operand error] */
#define     FPE_FLTOVF_TRAP     0xd4    /* [floating overflow] */
#define     FPE_FLTNAN_TRAP     0xd8    /* [floating Not-A-Number] */
#endif BFLY1

#ifdef BFLY2
#define	    FPE_INTOVF_TRAP	1	/* integer overflow */
#define	    FPE_INTDIV_TRAP	2	/* integer divide by zero */
#define	    FPE_DISABL_TRAP	3	/* floating point unit disabled */
#define	    FPE_INTCNV_TRAP	4	/* integer conversion overflow */
#define	    FPE_OPCODE_TRAP	5	/* unimplemented fp opcode */
#define	    FPE_PRIV_TRAP	6	/* fp privilege violation */
#define	    FPE_OPRAND_FAULT	7	/* fp reserved operand */
#define	    FPE_FLTDIV_FAULT	8	/* divide by zero floating fault */
#define	    FPE_FLTUND_FAULT	9	/* floating underflow fault */
#define	    FPE_FLTOVR_FAULT	10	/* floating overflow fault */
#define	    FPE_ILLINST_FAULT	11	/* illegal FPU instruction */
#define     FPE_INVLOP_FAULT	12	/* invalid operation */
#define	    FPE_INEXACT_FAULT	13	/* inexact result */
#define	    FPE_BOUNDS_TRAP	14	/* TBND integer bounds check */
#endif BFLY2

#define	SIGKILL	9	/* kill (cannot be caught or ignored) */
#define	SIGBUS	10	/* bus error */
#ifdef BFLY2
	/* codes for SIGBUS */
#define	    BUS_MISALIGNED_ACCESS	4	/* misaligned access */
#endif BFLY2
#define	SIGSEGV	11	/* segmentation violation */
#define	SIGSYS	12	/* bad argument to system call */
#define	SIGPIPE	13	/* write on a pipe with no one to read it */
#define	SIGALRM	14	/* alarm clock */
#define	SIGTERM	15	/* software termination signal from kill */
#define	SIGURG	16	/* urgent condition on IO channel */
#define	SIGSTOP	17	/* sendable stop signal not from tty */
#define	SIGTSTP	18	/* stop signal from tty */
#define	SIGCONT	19	/* continue a stopped process */
#define	SIGCHLD	20	/* to parent on child stop or exit */
#define	SIGCLD	SIGCHLD	/* compatibility */
#define	SIGTTIN	21	/* to readers pgrp upon background tty read */
#define	SIGTTOU	22	/* like TTIN for output if (tp->t_local&LTOSTOP) */
#define	SIGIO	23	/* input/output possible signal */
#define	SIGXCPU	24	/* exceeded CPU time limit */
#define	SIGXFSZ	25	/* exceeded file size limit */
#define	SIGVTALRM 26	/* virtual time alarm */
#define	SIGPROF	27	/* profiling time alarm */
#define SIGWINCH 28	/* window size changes */
#define SIGLOST 29	/* resource lost (eg, record-lock lost) */
#define SIGUSR1 30	/* user defined signal 1 */
#define SIGUSR2 31	/* user defined signal 2 */

#ifndef KERNEL
int	(*signal())();
#endif KERNEL


/*****************************************************************************
* sigvec() definitions:
******************************************************************************/
/*
 * Signal vector "template" used in sigvec call.
 */
#ifndef	ASSEMBLER
struct	sigvec {
	int	(*sv_handler)();	/* signal handler */
	int	sv_mask;		/* signal mask to apply */
	int	sv_flags;		/* see signal options below */
};
#endif	ASSEMBLER

/* sv_flags values */
#define SV_ONSTACK	0x00000001	/* take signal on signal stack */
#define SV_INTERRUPT	0x00000002	/* don't restart syscall on sigreturn*/
#ifdef butterfly
#define	SV_SYNCH	0x04000000	/* one-level restart on synch signals*/
#endif butterfly
#define sv_onstack sv_flags		/* 4.2 compatibility */

/* sv_handler predefined values */
#define	SIG_DFL		(int (*)())0
#define	SIG_IGN		(int (*)())1

#ifdef KERNEL
#define	SIG_CATCH	(int (*)())2
#define	SIG_HOLD	(int (*)())3
#endif KERNEL

#define	BADSIG		((int (*)())-1)	/* error return value from signal(3) */


/*****************************************************************************
* sigstack() definitions:
******************************************************************************/
/*
 * Structure used in sigstack call.
 */
#ifndef	ASSEMBLER
struct	sigstack {
	char	*ss_sp;			/* signal stack pointer */
	int	ss_onstack;		/* current status */
};


/*****************************************************************************
* sigreturn() definitions:
******************************************************************************/
/*****************************************************************************
* struct _sc_machine:
*	butterfly-specific portion of sigcontext (defined below).
*	The entire sigcontext is machine-specific in one sense, but pc,
*	etc are more-standard (and also VAX-original) architectural features.
*	All fields are written and read by kernel.
******************************************************************************/
struct _sc_machine {
	int	scm_sigsynch;	/* restart instruction after synchronous sig */
#ifdef BFLY1
	int	scm_fpstate_valid;
	int	scm_fpstate[MC6888A_MAX_STATE_SIZE];
#endif BFLY1
#ifdef BFLY2
	int	scm_r2;		/* r2/r9 needed to call sigreturn */
	int	scm_r9;
	int	scm_sxip;
	int	scm_snip;
	int	scm_sfip;
	int	scm_datapipe[9];
#endif BFLY2
};


/*****************************************************************************
* struct sigcontext:
*	Information pushed on stack by kernel when a signal is delivered,
*	and returned by sigreturn to kernel, to restore state following
*	execution of the signal handler.
*	It is also made available to the user handler, to allow the
*	handler to properly specify new state if a non-standard exit
*	from signal handler is performed.
*	Thus, all fields are written and read by kernel.
******************************************************************************/
struct	sigcontext {
	int	sc_onstack;		/* sigstack state to restore */
	int	sc_mask;		/* signal mask to restore */
	int	sc_sp;			/* sp to restore */
	int	sc_ap;			/* ap to restore */
#ifdef	BFLY1
	unsigned short	sc_sr;		/* psr to restore */
#ifndef KERNEL_GENASSYM
	int	sc_pc;			/* pc to restore */
#else KERNEL_GENASSYM
	short	sc_pc[2];		/* pc for xcompile genassym */
#endif KERNEL_GENASSYM
	unsigned short	sc_pad;         /* padding for alignment */
#endif  BFLY1
#ifdef	BFLY2
	int	sc_sr;			/* psr to restore */
	int	sc_pc;			/* pc to restore */
#endif	BFLY2
	struct  _sc_machine _sc_machine;
};

	
#endif	ASSEMBLER

#endif NSIG

/*****************************************************************************
* sigblock() definitions:
******************************************************************************/
/*
 * Macro for converting signal number to a mask suitable for
 * sigblock().
 */
#define sigmask(m)	(1 << ((m)-1))

#ifdef _BBN_POSIX_SUPPORT

/*
 *	POSIX definitions:
 */

#define SIG_ERR      (void(*)())-1

#ifndef ASSEMBLER
/*
 * Types.
 */
typedef int     sigset_t;               /* Signal set */

/*
 * Signal action structure.
 */
struct sigaction {
        void            (*sa_handler)();/* Handler function */
        sigset_t        sa_mask;        /* To be blocked while in handler */
        int             sa_flags;       /* Special flags (SA_) */
};
#endif ASSEMBLER

/*
 * Signal action special flags (sa_flags).
 */
#define SA_NOCLDSTOP    (1<<3)          /* No SIGCHLD when children stop */
 
/*
 * sigprocmask() "how" argument values.
 */
#define SIG_BLOCK       0       /* Block the specified signal(s) */
#define SIG_UNBLOCK     1       /* Unblock the specified signal(s) */
#define SIG_SETMASK     2       /* Block ONLY the specified signal(s) */

#endif _BBN_POSIX_SUPPORT
#endif _SIGNAL_H
