/* $Header: stat.h,v 1.7 89/10/19 22:24:37 nkeene Exp $ */
#ifndef _STAT_H
#define _STAT_H
#if	CMU
/* 
 **********************************************************************
 * Mach Operating System
 * Copyright (c) 1986 Carnegie-Mellon University
 *  
 * This software was developed by the Mach operating system
 * project at Carnegie-Mellon University's Department of Computer
 * Science. Software contributors as of May 1986 include Mike Accetta, 
 * Robert Baron, William Bolosky, Jonathan Chew, David Golub, 
 * Glenn Marcy, Richard Rashid, Avie Tevanian and Michael Young. 
 * 
 * Some software in these files are derived from sources other
 * than CMU.  Previous copyright and other source notices are
 * preserved below and permission to use such software is
 * dependent on licenses from those institutions.
 * 
 * Permission to use the CMU portion of this software for 
 * any non-commercial research and development purpose is
 * granted with the understanding that appropriate credit
 * will be given to CMU, the Mach project and its authors.
 * The Mach project would appreciate being notified of any
 * modifications and of redistribution of this software so that
 * bug fixes and enhancements may be distributed to users.
 *
 * All other rights are reserved to Carnegie-Mellon University.
 **********************************************************************
 */
#endif	CMU
/*
 * Copyright (c) 1982, 1986 Regents of the University of California.
 * All rights reserved.  The Berkeley software License Agreement
 * specifies the terms and conditions for redistribution.
 *
 *	@(#)stat.h	7.1 (Berkeley) 6/4/86
 *	@(#)stat.h	2.1 88/05/18 4.0NFSSRC SMI; from 7.1 (Berkeley) 6/4/86
 */

struct	stat
{
	dev_t	st_dev;
	ino_t	st_ino;
	unsigned short st_mode;
	short	st_nlink;
	uid_t	st_uid;
	gid_t	st_gid;
	dev_t	st_rdev;
	off_t	st_size;
	time_t	st_atime;
	int	st_spare1;
	time_t	st_mtime;
	int	st_spare2;
	time_t	st_ctime;
	int	st_spare3;
	long	st_blksize;
	long	st_blocks;
	long	st_spare4[2];
};

/* old format stat structure. 'dev_t' truncated to a short */
struct	old_stat
{
	u_short	st_dev;
	ino_t	st_ino;
	unsigned short st_mode;
	short	st_nlink;
	uid_t	st_uid;
	gid_t	st_gid;
	u_short	st_rdev;
	off_t	st_size;
	time_t	st_atime;
	int	st_spare1;
	time_t	st_mtime;
	int	st_spare2;
	time_t	st_ctime;
	int	st_spare3;
	long	st_blksize;
	long	st_blocks;
	long	st_spare4[2];
};

#define	S_IFMT	0170000		/* type of file */
#define		S_IFDIR	0040000	/* directory */
#define		S_IFCHR	0020000	/* character special */
#define		S_IFBLK	0060000	/* block special */
#define		S_IFREG	0100000	/* regular */
#define		S_IFLNK	0120000	/* symbolic link */
#define		S_IFSOCK 0140000/* socket */
#define		S_IFIFO 0010000 /* fifo */

#define	S_ISUID	0004000		/* set user id on execution */
#define	S_ISGID	0002000		/* set group id on execution */
#define	S_ISVTX	0001000		/* save swapped text even after use */

#define	S_IREAD	0000400		/* read permission, owner */
#define	S_IWRITE 0000200	/* write permission, owner */
#define	S_IEXEC	0000100		/* execute/search permission, owner */
#define S_IRWXU 0000700           /* read, write, execute: owner */
#define S_IRUSR 0000400           /* read permission: owner */
#define S_IWUSR 0000200           /* write permission: owner */
#define S_IXUSR 0000100           /* execute permission: owner */
#define S_IRWXG 0000070           /* read, write, execute: group */
#define S_IRGRP 0000040           /* read permission: group */
#define S_IWGRP 0000020           /* write permission: group */
#define S_IXGRP 0000010           /* execute permission: group */
#define S_IRWXO 0000007           /* read, write, execute: other */
#define S_IROTH 0000004           /* read permission: other */
#define S_IWOTH 0000002           /* write permission: other */
#define S_IXOTH 0000001           /* execute permission: other */

/*
 * Mode macros. The argument "m" is the value of st_mode
 * from the stat structure.
 */
#define S_ISBLK(m)      \
        (((m) & S_IFMT) == S_IFBLK)     /* Block special file? */
#define S_ISCHR(m)      \
        (((m) & S_IFMT) == S_IFCHR)     /* Character special file? */
#define S_ISDIR(m)      \
        (((m) & S_IFMT) == S_IFDIR)     /* Directory? */
#define S_ISFIFO(m)     \
        (((m) & S_IFMT) == S_IFIFO)     /* FIFO? */
#define S_ISREG(m)      \
        (((m) & S_IFMT) == S_IFREG)     /* Regular file? */

#endif _STAT_H
