/* $Header: /nfs/columbia/u1/BFMACH.local/mk.gibson/h/RCS/types.h,v 1.19 90/12/05 16:12:55 gibson Exp $ */
#ifndef	types_h
#define	types_h	yes
#if	CMU
/* 
 **********************************************************************
 * Mach Operating System
 * Copyright (c) 1986 Carnegie-Mellon University
 *  
 * This software was developed by the Mach operating system
 * project at Carnegie-Mellon University's Department of Computer
 * Science. Software contributors as of May 1986 include Mike Accetta, 
 * Robert Baron, William Bolosky, Jonathan Chew, David Golub, 
 * Glenn Marcy, Richard Rashid, Avie Tevanian and Michael Young. 
 * 
 * Some software in these files are derived from sources other
 * than CMU.  Previous copyright and other source notices are
 * preserved below and permission to use such software is
 * dependent on licenses from those institutions.
 * 
 * Permission to use the CMU portion of this software for 
 * any non-commercial research and development purpose is
 * granted with the understanding that appropriate credit
 * will be given to CMU, the Mach project and its authors.
 * The Mach project would appreciate being notified of any
 * modifications and of redistribution of this software so that
 * bug fixes and enhancements may be distributed to users.
 *
 * All other rights are reserved to Carnegie-Mellon University.
 **********************************************************************
 */

#ifdef	KERNEL
#include "cs_generic.h"
#else	KERNEL
#include <sys/features.h>
#endif	KERNEL
#endif	CMU
/*
 * Copyright (c) 1982, 1986 Regents of the University of California.
 * All rights reserved.  The Berkeley software License Agreement
 * specifies the terms and conditions for redistribution.
 *
 *	@(#)types.h	7.1 (Berkeley) 6/4/86
 *	@(#)types.h	2.2 88/06/13 4.0NFSSRC SMI; from 7.1 (Berkeley) 6/4/86
 */

#ifndef	ASSEMBLER

#ifndef _TYPES_
#define	_TYPES_

#ifdef BFLY1
#ifdef	KERNEL
#include "../machine/fpu.h"
#else	KERNEL
#include <machine/fpu.h>
#endif	KERNEL
#endif BFLY1

/*
 * Basic system types and major/minor device constructing/busting macros.
 */

/*
 * New format big dev_t
 * a dev_t is composed of the following parts, starting at the MSB
 *   1 bit - Reserved
 *   9 bits - iobus
 *   6 bits - major device
 *   4 bits - reserved
 *   12 bits - minor device
 */
#define DEV_T_MAJORSHIFT 16
#define DEV_T_MAJORMASK 0x3F	/* 6 bits */
#define DEV_T_IOBUSMASK 0x1FF	/* 9 bits */
#define DEV_T_IOBUSSHIFT 22
#define DEV_T_MINORSHIFT 0
#define DEV_T_MINORMASK 0xFFF	/* 12 bits */

#define makedev(x, y, z) (dev_t)((((x)&DEV_T_MAJORMASK)<<DEV_T_MAJORSHIFT) | \
				 (((z)&DEV_T_IOBUSMASK)<<DEV_T_IOBUSSHIFT) | \
				 ((y)&DEV_T_MINORMASK))

#define major(dev) (int)(((dev)>>DEV_T_MAJORSHIFT)&DEV_T_MAJORMASK)
#define minor(dev) (int)(((dev)>>DEV_T_MINORSHIFT)&DEV_T_MINORMASK)
#define iobusid(dev)  (int)(((dev)>>DEV_T_IOBUSSHIFT)&DEV_T_IOBUSMASK)
#define MASTER_IOBUS	(-1)	/* High bus ID always refers to the master */
#define NFS_IOBUS	(-2)	/* Special bus ID for remote file systems */
#define ALLNODE_IOBUS	(-3)	/* Special bus for devices that exist on */
 				/* all nodes */
#define SPECIAL_IOBUS	(ALLNODE_IOBUS&DEV_T_IOBUSMASK)	/* start of reserved range */

#if	CS_GENERIC
#ifdef	KERNEL
#include "../h/vm.h"
#else	KERNEL
#ifndef STANDALONE	/* Why is vm.h included?  For now, protect bootstraps */
#include <sys/vm.h>
#endif STANDALONE
#endif	KERNEL
#endif	CS_GENERIC
typedef	unsigned char	u_char;
typedef	unsigned short	u_short;
typedef	unsigned int	u_int;
typedef	unsigned long	u_long;
typedef	unsigned short	ushort;		/* sys III compat */

#ifdef	butterfly
typedef struct  _physadr { short r[1]; } *physadr;

#ifdef	BFLY1
typedef struct fp_context {
  int	fp_cr;		
  int	fp_sr;		
  int	fp_iar;
  int	fp_regs[24];
  int	fp_state[MC6888A_MAX_STATE_SIZE];
  int	fp_null;
  int	fp_state_ptr;
}  fp_context;
typedef struct  label_t {
        int     val[13];
	fp_context fp;
} label_t;
#endif	BFLY1

#ifdef	BFLY2
typedef struct  label_t {
        int     val[20];
} label_t; 
#endif BFLY2
#endif	butterfly

#if	CS_GENERIC
typedef	struct	_quad { u_long val[2]; } quad;
#else	CS_GENERIC
typedef	struct	_quad { long val[2]; } quad;
#endif	CS_GENERIC
typedef	long	daddr_t;
typedef	char *	caddr_t;
typedef	u_long	ino_t;
typedef	long	swblk_t;
typedef	long	size_t;
typedef	long	time_t;
typedef	u_long	dev_t;
#if	CS_GENERIC
typedef	u_long	off_t;
#else	CS_GENERIC
typedef	long	off_t;
#endif	CS_GENERIC
typedef	short	uid_t;
typedef	short	gid_t;

typedef unsigned short	mode_t;		/* access permissions */
typedef long          	clock_t;        /* clock ticks */
typedef unsigned short	nlink_t;	/* link count */
typedef int		pid_t;		/* process ID */

#define	NBBY	8		/* number of bits in a byte */
/*
 * Select uses bit masks of file descriptors in longs.
 * These macros manipulate such bit fields (the filesystem macros use chars).
 * FD_SETSIZE may be defined by the user, but the default here
 * should be >= NOFILE (param.h).
 */
#ifndef	FD_SETSIZE
#define	FD_SETSIZE	256
#endif

typedef long	fd_mask;
#define NFDBITS	(sizeof(fd_mask) * NBBY)	/* bits per mask */
#ifndef howmany
#define	howmany(x, y)	(((x)+((y)-1))/(y))
#endif

typedef	struct fd_set {
	fd_mask	fds_bits[howmany(FD_SETSIZE, NFDBITS)];
} fd_set;

#define	FD_SET(n, p)	((p)->fds_bits[(n)/NFDBITS] |= (1 << ((n) % NFDBITS)))
#define	FD_CLR(n, p)	((p)->fds_bits[(n)/NFDBITS] &= ~(1 << ((n) % NFDBITS)))
#define	FD_ISSET(n, p)	((p)->fds_bits[(n)/NFDBITS] & (1 << ((n) % NFDBITS)))
#define FD_ZERO(p)	bzero((char *)(p), sizeof(*(p)))

#endif

#endif	ASSEMBLER
#endif types_h
