/* $Header: /nfs/europa/u1/BFMACH.local/mk.gibson.MV_KERN/kdb/RCS/machine.h,v 1.14 90/09/04 14:21:54 gibson Exp $ */
/*
 ****************************************************************
 * Mach Operating System
 * Copyright (c) 1986 Carnegie-Mellon University
 *  
 * This software was developed by the Mach operating system
 * project at Carnegie-Mellon University's Department of Computer
 * Science. Software contributors as of May 1986 include Mike Accetta, 
 * Robert Baron, William Bolosky, Jonathan Chew, David Golub, 
 * Glenn Marcy, Richard Rashid, Avie Tevanian and Michael Young. 
 * 
 * Some software in these files are derived from sources other
 * than CMU.  Previous copyright and other source notices are
 * preserved below and permission to use such software is
 * dependent on licenses from those institutions.
 * 
 * Permission to use the CMU portion of this software for 
 * any non-commercial research and development purpose is
 * granted with the understanding that appropriate credit
 * will be given to CMU, the Mach project and its authors.
 * The Mach project would appreciate being notified of any
 * modifications and of redistribution of this software so that
 * bug fixes and enhancements may be distributed to users.
 *
 * All other rights are reserved to Carnegie-Mellon University.
 ****************************************************************
 */
/*	machine.h	4.1	81/05/14	*/

#include "../h/vm.h"

#ifndef PAGSIZ		/* don't redefine this if already defined */
#define	PAGSIZ		(NBPG*CLSIZE)
#endif  PAGSIZ

#define DBNAME "kdb\n"
#define LPRMODE "%R"
#define OFFMODE "+%R"
#define	TXTRNDSIZ	PAGSIZ

/*
 * INSTACK tells whether its argument is a stack address.
 * INUDOT tells whether its argument is in the (extended) u. area.
 * These are used for consistency checking and dont have to be exact.
 *
 * INKERNEL tells whether its argument is a kernel space address.
 * KVTOPH trims a kernel virtal address back to its offset
 * in the kernel address space.
 */
#ifdef butterfly
#define	KERNOFF		((unsigned)KERNEL_TEXT_VADDR)

#define	INSTACK(x)	(((unsigned)x) < KERNOFF)
#define	INUDOT(x)	(((x)&0xffffe000) == 0xBFFFE000)
#define	INKERNEL(x)	(((unsigned)x) >= KERNOFF)

#define	KVTOPH(x)	((x)&~ 0xC0000000)
#else
#define	KERNOFF		0x80000000

#define	INSTACK(x)	(((x)&0xf0000000) == 0x70000000)
#define	INUDOT(x)	(((x)&0xf0000000) == 0x70000000)
#define	INKERNEL(x)	(((x)&0xf0000000) == 0x80000000)

#define	KVTOPH(x)	((x)&~ 0x80000000)
#endif butterfly

#define	MAXINT	0x7fffffff
#ifdef butterfly
#define	MAXSTOR ((unsigned) KERNOFF - ctob(UPAGES))
#else
#define	MAXSTOR ((1L<<31) - ctob(UPAGES))
#endif butterfly
#define	MAXFILE 0xffffffff

