/* $Header: syscall_sw.h,v 1.12 89/10/07 21:47:16 rschaaf Exp $ */
/*
 ****************************************************************
 * Mach Operating System
 * Copyright (c) 1986 Carnegie-Mellon University
 *  
 * This software was developed by the Mach operating system
 * project at Carnegie-Mellon University's Department of Computer
 * Science. Software contributors as of May 1986 include Mike Accetta, 
 * Robert Baron, William Bolosky, Jonathan Chew, David Golub, 
 * Glenn Marcy, Richard Rashid, Avie Tevanian and Michael Young. 
 * 
 * Some software in these files are derived from sources other
 * than CMU.  Previous copyright and other source notices are
 * preserved below and permission to use such software is
 * dependent on licenses from those institutions.
 * 
 * Permission to use the CMU portion of this software for 
 * any non-commercial research and development purpose is
 * granted with the understanding that appropriate credit
 * will be given to CMU, the Mach project and its authors.
 * The Mach project would appreciate being notified of any
 * modifications and of redistribution of this software so that
 * bug fixes and enhancements may be distributed to users.
 *
 * All other rights are reserved to Carnegie-Mellon University.
 ****************************************************************
 */

#ifndef	_SYSCALL_SW_
#define	_SYSCALL_SW_	1

#ifdef	KERNEL
#ifndef LOCORE
typedef struct {
	short		mach_trap_length;
	short		mach_trap_flags;
	int		(*mach_trap_function)();
} mach_trap_t;
extern mach_trap_t	mach_trap_table[];
extern int		mach_trap_count;

#define	MACH_TRAP(name, arg_count, flags)	{ sizeof(int) * ((arg_count)+1), (flags), (name) }
#define	FF1(name,argno,flags)	MACH_TRAP(name, argno, 1<<flags)
#define	FN(name, argno)		MACH_TRAP(name, argno, 0)

#endif LOCORE

/*
 *	Flag values (actually bit numbers)
 */

#define ASETJMP		0
#define APSIG		2

#else	KERNEL

/*
 *	The machine-dependent "syscall_sw.h" file should
 *	define a macro for
 *		kernel_trap(trap_name, trap_number)
 *	which will expand into assembly code for the
 *	trap.
 */

#include <machine/syscall_sw.h>

/*
 *	These trap numbers should be taken from the
 *	table in "../kern/syscall_sw.c".
 */

#include <sys/features.h>

#if	MACH_TIME
kernel_trap(getutime, -53)
kernel_trap(set_timemode, -54)
kernel_trap(get_timemode, -55)
#endif	MACH_TIME

kernel_trap(task_self, -10)
kernel_trap(task_data, -11)
kernel_trap(task_notify, -12)
kernel_trap(msg_send, -14)
kernel_trap(msg_receive, -15)

kernel_trap(swtch, -60)

kernel_trap(vnode_swap_preference, -40)

kernel_trap(init_process, -41)

kernel_trap(port_by_pid, -88)
#endif	KERNEL

#endif	_SYSCALL_SW_
