/* $Header: vm_pmap.h,v 1.1 89/09/11 21:09:45 gibson Exp $ */
/*****************************************************************************
File:     vm_pmap.h
Contents: Physical Map / Virtual Memory Interface Definitions
System:   BBNACI Butterfly OS kernel, virtual memory subsystem.
Created:  Aug 16 1989

Author:   drb + jcg + rew

Remarks:

[And now, a few words from the legal department.]

Copyright 1989 by BBN Advanced Computers Inc.
ALL RIGHTS RESERVED

No part of this material may be reproduced, stored in a retrieval
system, transmitted or used in any form or by any means, electronic,
mechanical, photocopying, recording, or otherwise, without the prior
written permission of, or express license from BBN Advanced Computers Inc.

RESTRICTED RIGHTS LEGEND

Use, duplication, or disclosure by the Government is subject to
restrictions as set forth in subparagraph (c)(1)(ii) of the Rights to
Technical Data and Computer Software clause at DFARS 52.227-7013.

BBN Advanced Computers Inc.
10 Fawcett Street
Cambridge, Ma. 02238
617-873-6000
*****************************************************************************/

#ifndef	_VM_PMAP_H_
#define	_VM_PMAP_H_  1

/* ---- TLB / PTE cookie definition --------------------------------------- */

/* For each physical frame, we have at least one such cookie */
/* Each cookie describes a virtual mapping for the given frame */

struct vm_revpte
{
    vm_queue_data_t	revptes; /* list of similar cookies */
    pmap_t              pmap;	/* the pmap containing the */
    pt_entry_ptr_t      pte;	/* pte which maps */
    vm_addr_t           vaddr;	/* this page at said virtual address */
};

typedef struct vm_revpte vm_revpte;
typedef struct vm_revpte vm_revpte_data_t;

vm_zone_t   vm_revpte_zone [NCPUS];

#define VM_NO_PMAP ((pmap_t) 0xFFFFFFFF)
#define VM_REVPTE_ZONE(node)  (vm_revpte_zone[node])

#define PMAP_OLD_PAGE  1
#define PMAP_NEW_PAGE  2

pt_entry_ptr_t pmap_pte();
#endif	_VM_PMAP_H_
